using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace ArtCSB
{
	/// <summary>
	/// Summary description for WinForm.
	/// </summary>
	public class WinForm_Options : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Button button_OK;
		private System.Windows.Forms.Button button_CANCEL;
		protected internal System.Windows.Forms.NumericUpDown numericUpDown_OpacityValue;
		private System.Windows.Forms.Label label_OpacityValue;
		protected internal System.Windows.Forms.CheckBox checkBox_ShowInTaskBar;
		private System.Windows.Forms.GroupBox groupBox_Options;
		protected internal System.Windows.Forms.CheckBox checkBox_ExpandTrees;
		private System.Windows.Forms.ColorDialog colorDialogOPTIONS;
		private System.Windows.Forms.FontDialog fontDialogOPTIONS;

		public WinForm_Options(OptionsKind optKind)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			switch (optKind){
			case OptionsKind.Source:

				checkBox_ShowInTaskBar.Checked =
					Common.MyOps.SourceNavigator_ShowInTaskBar;
				checkBox_ExpandTrees.Checked =
					Common.MyOps.SourceNavigator_ExpandTrees;
				numericUpDown_OpacityValue.Value =
					decimal.Truncate(
						(decimal)(Common.MyOps.SourceNavigator_OpacityValue) * 100
					);

				break;
			case OptionsKind.Designer:

				checkBox_ShowInTaskBar.Checked =
					Common.MyOps.DesignerNavigator_ShowInTaskBar;
				checkBox_ExpandTrees.Checked =
					Common.MyOps.DesignerNavigator_ExpandTrees;
				numericUpDown_OpacityValue.Value =
					decimal.Truncate(
						(decimal)(Common.MyOps.DesignerNavigator_OpacityValue) * 100
					);

				break;
			}
		}
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose (bool disposing)
		{
			if (disposing)
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(WinForm_Options));
			this.button_OK = new System.Windows.Forms.Button();
			this.button_CANCEL = new System.Windows.Forms.Button();
			this.numericUpDown_OpacityValue = new System.Windows.Forms.NumericUpDown();
			this.label_OpacityValue = new System.Windows.Forms.Label();
			this.checkBox_ShowInTaskBar = new System.Windows.Forms.CheckBox();
			this.groupBox_Options = new System.Windows.Forms.GroupBox();
			this.checkBox_ExpandTrees = new System.Windows.Forms.CheckBox();
			this.colorDialogOPTIONS = new System.Windows.Forms.ColorDialog();
			this.fontDialogOPTIONS = new System.Windows.Forms.FontDialog();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown_OpacityValue)).BeginInit();
			this.groupBox_Options.SuspendLayout();
			this.SuspendLayout();
			// 
			// button_OK
			// 
			this.button_OK.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.button_OK.Location = new System.Drawing.Point(224, 160);
			this.button_OK.Name = "button_OK";
			this.button_OK.TabIndex = 0;
			this.button_OK.Text = "OK";
			this.button_OK.Click += new System.EventHandler(this.button_OK_Click);
			// 
			// button_CANCEL
			// 
			this.button_CANCEL.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.button_CANCEL.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.button_CANCEL.Location = new System.Drawing.Point(312, 160);
			this.button_CANCEL.Name = "button_CANCEL";
			this.button_CANCEL.TabIndex = 1;
			this.button_CANCEL.Text = "Cancel";
			this.button_CANCEL.Click += new System.EventHandler(this.button_CANCEL_Click);
			// 
			// numericUpDown_OpacityValue
			// 
			this.numericUpDown_OpacityValue.Location = new System.Drawing.Point(16, 96);
			this.numericUpDown_OpacityValue.Minimum = new decimal(new int[] {
						30,
						0,
						0,
						0});
			this.numericUpDown_OpacityValue.Name = "numericUpDown_OpacityValue";
			this.numericUpDown_OpacityValue.Size = new System.Drawing.Size(56, 20);
			this.numericUpDown_OpacityValue.TabIndex = 4;
			this.numericUpDown_OpacityValue.Value = new decimal(new int[] {
						50,
						0,
						0,
						0});
			// 
			// label_OpacityValue
			// 
			this.label_OpacityValue.AutoSize = true;
			this.label_OpacityValue.Location = new System.Drawing.Point(80, 98);
			this.label_OpacityValue.Name = "label_OpacityValue";
			this.label_OpacityValue.Size = new System.Drawing.Size(206, 16);
			this.label_OpacityValue.TabIndex = 5;
			this.label_OpacityValue.Text = "Opacity value (%) of Designer Navigator";
			// 
			// checkBox_ShowInTaskBar
			// 
			this.checkBox_ShowInTaskBar.Checked = true;
			this.checkBox_ShowInTaskBar.CheckState = System.Windows.Forms.CheckState.Checked;
			this.checkBox_ShowInTaskBar.Location = new System.Drawing.Point(16, 56);
			this.checkBox_ShowInTaskBar.Name = "checkBox_ShowInTaskBar";
			this.checkBox_ShowInTaskBar.Size = new System.Drawing.Size(328, 24);
			this.checkBox_ShowInTaskBar.TabIndex = 6;
			this.checkBox_ShowInTaskBar.Text = "Show Designer Navigator in Task Bar";
			// 
			// groupBox_Options
			// 
			this.groupBox_Options.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
						| System.Windows.Forms.AnchorStyles.Left) 
						| System.Windows.Forms.AnchorStyles.Right)));
			this.groupBox_Options.Controls.Add(this.checkBox_ExpandTrees);
			this.groupBox_Options.Controls.Add(this.checkBox_ShowInTaskBar);
			this.groupBox_Options.Controls.Add(this.numericUpDown_OpacityValue);
			this.groupBox_Options.Controls.Add(this.label_OpacityValue);
			this.groupBox_Options.Location = new System.Drawing.Point(9, 8);
			this.groupBox_Options.Name = "groupBox_Options";
			this.groupBox_Options.Size = new System.Drawing.Size(376, 136);
			this.groupBox_Options.TabIndex = 7;
			this.groupBox_Options.TabStop = false;
			// 
			// checkBox_ExpandTrees
			// 
			this.checkBox_ExpandTrees.Checked = true;
			this.checkBox_ExpandTrees.CheckState = System.Windows.Forms.CheckState.Checked;
			this.checkBox_ExpandTrees.Location = new System.Drawing.Point(16, 24);
			this.checkBox_ExpandTrees.Name = "checkBox_ExpandTrees";
			this.checkBox_ExpandTrees.Size = new System.Drawing.Size(328, 24);
			this.checkBox_ExpandTrees.TabIndex = 7;
			this.checkBox_ExpandTrees.Text = "Expand object trees after Refresh command";
			// 
			// WinForm_Options
			// 
			this.AcceptButton = this.button_OK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.button_CANCEL;
			this.ClientSize = new System.Drawing.Size(394, 192);
			this.ControlBox = false;
			this.Controls.Add(this.button_CANCEL);
			this.Controls.Add(this.button_OK);
			this.Controls.Add(this.groupBox_Options);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "WinForm_Options";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "ArtCSB Designer Navigator Options";
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown_OpacityValue)).EndInit();
			this.groupBox_Options.ResumeLayout(false);
			this.ResumeLayout(false);
		}
		#endregion

		private void button_OK_Click(object sender, System.EventArgs e) {
			this.DialogResult = DialogResult.OK;
		}

		private void button_CANCEL_Click(object sender, System.EventArgs e) {
			this.DialogResult = DialogResult.Cancel;
		}
	}
}
