using System;
using System.Drawing;
using System.Windows.Forms;
using Borland.Studio.ToolsAPI;

namespace ArtCSB
{
	/// <summary>
	/// Summary description for Class.
	/// </summary>
	public class Wizard_SourceNavigator
	{
		//private static int AboutPluginIndex = -1;
		public static readonly string IDE_MENU_ITEM_NAME = "ViewObjInspItem";
		private static readonly string MenuItemName = "ArtCSBMenuItem_SourceNavigator";
		private static IOTAMenuItem menuItem = null;
		private static WinForm_SourceNavigator wSourceNavigator=null;


		protected static void AddMainMenuItem()
		{
			IOTAMainMenuService menuServ = OTAUtils.MainMenuService;
			Icon ico =
				((Icon)(Common.MyRes.GetObject("SourceNavigator16x16.ico")));
			menuItem = menuServ.AddMenuItem(
				//IDEViewDebugItemName, //referenceItemName
				IDE_MENU_ITEM_NAME,
				OTAMenuItemLocation.otamlAfter, //newLocation
				MenuItemName, //newName
				"ArtCSB Source Navigator", //newText
				ico.ToBitmap().GetHbitmap()
			);
			menuItem.Executed += new EventHandler(MenuItemExecuted);
			int shortcut =
				Convert.ToInt32(Keys.F12) | OTAUtils.keyControl | OTAUtils.keyAlt;
			menuItem.Shortcut = shortcut;
			OTAUtils.StartUpdatingMenuShortcut(menuItem, shortcut);
		}

		private static void MenuItemExecuted(object sender, EventArgs e)
		{
			if ((wSourceNavigator == null) || (wSourceNavigator.IsDisposed))
			{
				wSourceNavigator = new WinForm_SourceNavigator();
			}
			wSourceNavigator.Show();
		}

		public static void Register()
		{
			wSourceNavigator = new WinForm_SourceNavigator();
			AddMainMenuItem();
		}

	}
}
