{-------------------------------------------------------------------------------
  DelphiCodeToDoc is a free documentation system for Delphi
  It uses information about source code symbols and formatted comments in files
  to produce accurate documentation from your application and component.

  http://dephicodetodoc.sourceforge.net/
  Copyright TridenT 2003 - Under GNU GPL licence

  @Author    TridenT
  @Version   2003/12/01   TridenT   v0.0     Initial revision
-------------------------------------------------------------------------------}

program DelphiCodeToDoc;



uses
  Forms,
  Converter in 'ReadWrite\Converter.pas',
  CodeReader in 'ReadWrite\CodeReader.pas',
  CodeWriter in 'ReadWrite\CodeWriter.pas',
  StringsReader in 'ReadWrite\StringsReader.pas',
  StringsWriter in 'ReadWrite\StringsWriter.pas',
  StringsConverter in 'ReadWrite\StringsConverter.pas',
  ConvertTypes in 'ReadWrite\ConvertTypes.pas',
  BuildParseTree in 'Parse\BuildParseTree.pas',
  BuildTokenList in 'Parse\BuildTokenList.pas',
  ParseError in 'Parse\ParseError.pas',
  ParseTreeNode in 'Parse\ParseTreeNode.pas',
  ParseTreeNodeType in 'Parse\ParseTreeNodeType.pas',
  SourceToken in 'Parse\SourceToken.pas',
  SourceTokenList in 'Parse\SourceTokenList.pas',
  VisitSetXY in 'Process\VisitSetXY.pas',
  BaseVisitor in 'Process\BaseVisitor.pas',
  VisitParseTree in 'Process\VisitParseTree.pas',
  JcfMiscFunctions in 'Utils\JcfMiscFunctions.pas',
  FileUtils in 'Utils\FileUtils.pas',
  JcfLog in 'Utils\JcfLog.pas',
  fShowParseTree in 'Parse\UI\fShowParseTree.pas' {frmShowParseTree},
  TokenUtils in 'Parse\TokenUtils.pas',
  Nesting in 'Process\Nesting.pas',
  VisitSetNesting in 'Process\VisitSetNesting.pas',
  VisitStripEmptySpace in 'Process\VisitStripEmptySpace.pas',
  BasicStats in 'Process\Info\BasicStats.pas',
  Tokens in 'Parse\Tokens.pas',
  PreProcessorTokens in 'Parse\PreProcessor\PreProcessorTokens.pas',
  PreProcessor in 'Parse\PreProcessor\PreProcessor.pas',
  PreProcessorParse in 'Parse\PreProcessor\PreProcessorParse.pas',
  PreProcessorTokenise in 'Parse\PreProcessor\PreProcessorTokenise.pas',
  AllProcesses in 'Process\AllProcesses.pas',
  Structure in 'Process\Extract\Structure.pas',
  VisitStructure in 'Process\Extract\VisitStructure.pas',
  DocGen in 'Process\Extract\DocGen.pas',
  DocGenTXT in 'Process\Extract\DocGenTXT.pas',
  DocGenHTML in 'Process\Extract\DocGenHTML.pas',
  DocGenHTML_Common in 'Process\Extract\DocGenHTML_Common.pas',
  uDocProject in 'Process\Extract\uDocProject.pas',
  fWizardProject in 'UI\fWizardProject.pas' {WizardProjectForm},
  fMainForm in 'UI\fMainForm.pas' {MainForm},
  fAbout in 'UI\fAbout.pas' {AboutBox},
  TagComment in 'Parse\TagComment.pas',
  VisitComment in 'Process\Extract\VisitComment.pas',
  uOptions in 'Process\Extract\uOptions.pas';

{$R *.res}

begin
  Application.Initialize;
  Application.Title := 'DelphiCodeToDoc by TridenT';
  Application.CreateForm(TMainForm, MainForm);
  Application.Run;
end.
