// ABoutBox display Project Infos
unit fAbout;

interface

uses Windows, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, SysUtils, Grids, ValEdit;

type
  TAboutBox = class(TForm)
    Panel1: TPanel;
    OKButton: TButton;
    Copyright: TLabel;
    ProductVersion: TMemo;
    ProductIcon: TImage;
    ProductDescription: TMemo;
    ProductName: TLabel;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  AboutBox: TAboutBox;

implementation

{$R *.DFM}

procedure TAboutBox.FormCreate(Sender: TObject);
const
  InfoNum = 10;
  InfoStr: array[1..InfoNum] of string = ('CompanyName', 'FileDescription'
    , 'FileVersion', 'InternalName', 'LegalCopyright', 'LegalTradeMarks'
    , 'OriginalFileName', 'ProductName', 'ProductVersion', 'Comments');
var
  S: string;
  n, Len, i: DWORD;
  Buf: PChar;
  Value: PChar;
begin
  S := Application.ExeName;
  n := GetFileVersionInfoSize(PChar(S), n);
  if n > 0 then
  begin
    Buf := AllocMem(n);
    GetFileVersionInfo(PChar(S), 0, n, Buf);
    for i := 1 to InfoNum do
      if VerQueryValue(Buf, PChar('StringFileInfo\040904E4\' + InfoStr[i]),
        Pointer(Value), Len) then
        if Value <> PChar('') then
        begin
          ProductVersion.Lines.Add(InfoStr[i] + ' = [' + Value + ']');
          if i = 7 then ProductName.Caption := Value;
        end;
    FreeMem(Buf, n);
  end
  else
    ProductVersion.Lines.Add('No version information found');
end;

end.
