{-------------------------------------------------------------------------------
  Help to build a project with the Wizard

  http://dephicodetodoc.sourceforge.net/
  Copyright TridenT 2003 - Under GNU GPL licence

  @Author    TridenT
  @Version   2003/12/01   TridenT   v0.0     Initial revision
-------------------------------------------------------------------------------}

unit fWizardProject;

interface

uses
  Windows, SysUtils, Classes, Controls, Forms,
  Dialogs, JvBrowseFolder, StdCtrls, JvLabel, ExtCtrls, JvToolEdit, Mask;

type
  TWizardProjectForm = class(TForm)
    JvDirectoryEditRoot: TJvDirectoryEdit;
    JvLabel1: TJvLabel;
    JvLabel2: TJvLabel;
    JvDirectoryEditOUtput: TJvDirectoryEdit;
    leProjectName: TLabeledEdit;
    Button1: TButton;
    Label1: TLabel;
    procedure JvDirectoryEditAfterDialog(Sender: TObject;
      var Name: string; var Action: boolean);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function GetRootDirectory: TFilename;
    function GetOutputDirectory: TFilename;
    function GetProjectName: string;
  end;

var
  WizardProjectForm: TWizardProjectForm;

implementation

{$R *.dfm}

resourcestring
  wpEmptyDirectory = 'Root directory and Output directory must be filled !';

  
procedure TWizardProjectForm.JvDirectoryEditAfterDialog(Sender: TObject;
  var Name: string; var Action: boolean);
begin
  // Check entry's validity
  if (Action = False) then (Sender as TJvDirectoryEdit).Text := '';
end;

procedure TWizardProjectForm.Button1Click(Sender: TObject);
begin
  if ((JvDirectoryEditOUtput.Text = '') or (JvDirectoryEditRoot.Text = '')) then
    MessageDlg(wpEmptyDirectory, mtError, [mbOK], 0)
  else 
    self.ModalResult := mrOk;
end;

function TWizardProjectForm.GetOutputDirectory: TFilename;
begin
  Result := JvDirectoryEditOUtput.Text + '\';
end;

function TWizardProjectForm.GetProjectName: string;
begin
  Result := leProjectName.Text;
end;

function TWizardProjectForm.GetRootDirectory: TFilename;
begin
  // return Directory including \ char at the end. Not compatible with LInuX
  Result := JvDirectoryEditRoot.Text + '\';
end;

procedure TWizardProjectForm.FormCreate(Sender: TObject);
begin
  //JvDirectoryEditRoot.Text:='D:\temp';
  JvDirectoryEditOUtput.Text := ExtractFilePath(Application.ExeName) + 'out';
  //JvDirectoryEditOUtput.Enabled:=false;
end;

end.
