Unit jbEdit;
{
 Extended component TEdit
 (c) 1997-02 J.BENES, All right reserved
   E-mail:"JBenes@micrel.cz"
 Procedure Parser
 (c) 1997 Antonie Baars, All right reserved
   E-mail:"d950021@icpc00.icpc.fukui-u.ac.jp"
}
Interface
{$I jb.inc}
{$Define emptymaskrequired}
{When you haven't got a RxLib then do comment next line}
{$Define useRXlibrary}
Uses
  WinTypes, WinProcs, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Menus, Dialogs, StdCtrls, Buttons, Mask
  {$IfDef useRXlibrary}, ToolEdit, CurrEdit, RXCtrls, FileCtrl, DateUtil{$EndIf useRXlibrary}
  {$IfDef VER6UP},maskutils{$EndIf};

{
Uvodem:
-------

Rozsireni vzniklo pro validaci dat a pro zmenu barvy pole pri disablovanem
poli. Pri teto prilezitosti jsem pridal dalsi eventy a nove property.


Rozsireni:
Nove property:
--------------

Alignment - zarovnani (left, center, right)

Capitalize - pocatecni pismena jsou konvertovana na velka

ColorOnDisabled
ColorOnFocus
ColorOnNotFocus - zmena barev pro zamerene pole, hlavne zmena
                  kdyz pole ma enabled=false

EditType - je mozno si vybrat mezi stringem, celym cislem, floatem a
           parserem pro vyhodnoceni jednoduchych vyrazu. Vyhodnoceni se
           deje pri ztrate focusu. Je-li typem cislo, je testovano, zda je
           cislem platnym a interne je sledovan vstup znaku na cisla.
           Parserem je mozne ohodnocovat vyrazu napr. vyraz
             sqrt(0.5*exp(x)-0.5*exp(y))


Mask - v tomto retezci se uschovava maska k formatovani dle nejakych
       pravidel. Zde se nic neformatuje, predpoklada se specialni vnejsi rutina,
       povesena na OnMask.

Required - nastavuje se na True, je-li pozadovano neprazdne pole.

ValidChars - retezec, kde se uschovavaji platne znaky, test se provadi pouze pro
             typ EditType = teString;

Nove events:
------------

OnConvert - lze pouzit pro konverzi pri EditType = teInteg ze soustavy
            napr. oktalove do desitkove k editaci a zpet. Smer konverze je
            udavan promenou ToDirection, ktera nabyva dvou hodnot:

            ** zde je priklat pouziti s uzitim rutin z jbStr.Pas modulu **

            procedure TForm1.PubEdit1Convert(Sender: TObject;
              ToDirection: TToDirection; var Value: OpenString);
            begin
              If Value <> '' Then // jen kdyz je treba
                Case ToDirection of
                  // hodnota se meni z oktalove na desitkovou
                  eValueToText: Value := IntToStr(Num(Value,8));
                  // hodnota se meni z desitkove zpet na oktalovou
                  eTextToValue: Value := Doc(StrToInt(Value),8);
                End;
            end;

OnError - umoznuje zakryt standardni hlasky a nahradit je svymi.

OnMask - umoznuje formatovat retezec v editacnim poli pri
         EditType = teString; Znamena to, ze tam mohou byt ruzne
         znaky, ktere se az nasledne zaformatuji.

         ** zde je priklat pouziti s uzitim rutin z jbStr modulu **

         procedure TForm1.PubEdit1Mask(Sender: TObject; ToDirection: TToDirection;
           Mask: String; var Value: OpenString);
         begin
           If Value <> '' Then // jen kdyz je treba
             Case ToDirection of
               // formatujeme 10 mistne rodne cislo
               // editovat se bude pouze text, je vhodne jeste nastavit
               // ValidChars := '0123456789'
               // odstranuji se vsechny oddelovace pred editaci
               eValueToText:Value:=Strip('XX XX XX XXXX',Value);
               // vkladaji se oddelovace po editaci
               eTextToValue:Value:=Zip('XX.XX.XX/XXXX',Value);
             End;
         end;

         Pozn. Funkce je vyvolana dvakrat - poprve regulerne pro upravu
               a podruhe pri validaci, nebot validace musi probehnout na
               originalnim poli bez oddelovacu, kvuli snadne kontrole.
               Neni to zrovna dobre reseni...

OnValidate - hlavni funkce pro ohodnoceni zda je vysledne pole v normalu
             ci nikoliv, kvuli ktere jsem tohle delal.

             ** Priklad na overeni rodneho cisla **

             procedure TForm1.PubEdit1Validate(Sender: TObject;
               Value: String;
               var CanExit: Boolean);
             Var E:Extended; // lokalni promenna
             begin
               CanExit:=True; // signal dopredu vse OK
               If Value='' Then Exit; // kdyz je pole prazdne, ven
               E:=StrToFloat(Value); // mozna zde to dat do try-except
               E:=E-11*(E/11); // vlastni overeni spravnosti
               CanExit := E=0; // spravne, kdyz je zbytek 0
             end;

Pouziti:
--------

Komponent je mozne volne (FREE) pouzit, s prihlednutim k soubeznym pravum.
Pouziti je na vlastni odpovednost uzivatele, nedavam zadne dalsi zaruky
pokud to neni nekde vyslovne uvedeno. Budete-li chtit zmenit cokoliv v teto
verzi, naleznete-li nejakou chybu nebo hodlate zvysit pouzitelnost,
dejte mi to, prosim, na vedomi.

Kontakt:
--------
Jaro Benes
E-mail:JBenes@micrel.cz
http://www.micrel.cz/delphi/
}
Const
  tyVersion          ='1.05 CZ';
  tyToAuthor         ='mailto="JBenes@micrel.cz"';
  {$IfNDef msgAsEngList}
  msgNoFloatValue    ='Pole neobsahuje platn FP slo';
  msgNoIntegerValue  ='Pole neobsahuje platn slo';
  msgFieldRequired   ='Pole je poadovno vyplnit';
  msgMissingLBracket ='Chyb "("';
  msgMissingRBracket ='Chyb ")"';
  msgSyntaxError     ='Chyba syntaxe vrazu';
  msgUnknownFnc      ='Neznam funkce';
  msgInvalidOperation='Chybn operace';
  msgConvertValue    ='Chybn slo nebo operace na nm';
  msgFieldInvalidate ='Pole je chybn obsahem';
  {$Else msgAsEngList}
  msgNoFloatValue    ='Field isn''t valid FP number';
  msgNoIntegerValue  ='Filed isn''t valid number';
  msgFieldRequired   ='Field required fill';
  msgMissingLBracket ='Missing "("';
  msgMissingRBracket ='Missing ")"';
  msgSyntaxError     ='Error expression syntax';
  msgUnknownFnc      ='Unknown function';
  msgInvalidOperation='Bad operation';
  msgConvertValue    ='Bad number or operation on it';
  msgFieldInvalidate ='Field is bad';
  {$EndIf msgAsEngList}

Type
  TPaintLineHintWindow = class(THintWindow)
  private
  public
    procedure Paint; override;
    procedure CreateParams(var Params: TCreateParams); override;
  end;

Type
  EvaluatorError=Class(Exception);
  {ohodnocujici procedura 11.11.1997}
  TValidate = Procedure (Sender: TObject;
                         Var Value: String;
                         Var CanExit: Boolean) Of Object;
  TToDirection = (eValueToText,eTextToValue);
  TConvert  = Procedure (Sender: TObject;
                         ToDirection:TToDirection;
                         Var Value:String) Of Object;
  TMaskForm = Procedure (Sender:TObject;
                         ToDirection:TToDirection;
                         Mask:String;
                         Var Value:String) Of Object;
  TErrorOccur = Procedure(Sender:TObject;
                          Const ErrorMsg:String) Of Object;
  {jak se zachovat k poli}
  TTypeEdit = (teString, teInteg, teFloat, teParser);

  TColorOptionsSet = Class (TPersistent)
  Private
    FColorFocus   : TColor;  {barvicky}
    FFontColorFocus: TColor; {barva pro focus fontu}
    FFontColorUnFocus: TColor;
    FColorUnFocus : TColor;
    FDisabledColor: TColor;
    FFontDisabledColor: TColor;
    Constructor Create;
  Published
    property  ColorOnFocus : TColor read FColorFocus write FColorFocus default clYellow;
    property  ColorOnFocusFont : TColor read FFontColorFocus write FFontColorFocus default clBlack;
    property  ColorOnNotFocusFont : TColor read FFontColorUnFocus write FFontColorUnFocus default clBlack;
    property  ColorOnNotFocus : TColor read FColorUnFocus write FColorUnFocus default clWindow;
    property  ColorOnDisabled : TColor read FDisabledColor write FDisabledColor default clBtnFace;
    property  ColorOnDisabledFont : TColor read FFontDisabledColor write FFontDisabledColor default clGrayText;
  End;

  TPubEdit = Class(TEdit)
   Private
    { Private declarations }
    FShowing: Boolean; {True, pokud je hint okno aktivni}
    FSelectAll: Boolean;
    FWider: Boolean; {text je sirsi}
    FWindow: TForm; {extra instance formu zastupna pro cancas}
    FHintText: Boolean; {zvlastni instance}
    {}
    FOnMouseExit: TNotifyEvent;
    FOnMouseEnter: TNotifyEvent;
    FAlignment    : TAlignment;
    FTypeEdit     : TTypeEdit; {typ pole s ruznymi akcemi}
    FValidate     : TValidate; {eventy}
    FConvert      : TConvert;
    FErrorOccur   : TErrorOccur;
    FMaskForm     : TMaskForm;
    FRequired     : Boolean; {neprazdne pole}
    FCapitalize   : Boolean; {prvni znaky slov velke}
    FOnEnter      : TNotifyEvent;
    FOnExit       : TNotifyEvent;
    FValids       : String;  {platne znaky napr. 'abcABC'}
    FMask         : String;  {maska napriklad 'XX.XX.XX/XX-XX'}
    FColorOptionsSet:TColorOptionsSet;
    procedure SetAlignment(Value: TAlignment);
    Procedure SetRequired(Value:Boolean);
    Procedure SetCapitalize(Value:Boolean);
    Procedure SetAsInteger(Value: Integer);
    Function  GetAsInteger: Integer;
    Procedure SetAsFloat(Value: Real);
    Function  GetAsFloat: Real;
    Procedure SetAsDate(Value: TDate);
    Function  GetAsDate: TDate;
    Procedure SetAsTime(Value: TTime);
    Function  GetAsTime: TTime;
    procedure ReleaseIt;
   Protected
    { Protected declarations }
    procedure CreateParams(var Params: TCreateParams); override;
    procedure KeyPress(var Key: Char); Override;
    procedure DoEnter; override;
    procedure DoExit ; override;
    procedure CMEnter( Var Message : TCMEnter ); Message CM_ENTER;
    procedure CMExit( Var Message : TCMExit ); Message CM_EXIT;
    procedure CMEnabledChanged( Var Message : TMessage ); Message CM_ENABLEDCHANGED;
    procedure CMMouseEnter(var message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var message: TMessage); message CM_MOUSELEAVE;
    Procedure NextControl( YesNo:Boolean) ; {nepouzil jsem}
   Public
    HintWin: TPaintLineHintWindow;
    Constructor Create(AOwner : TComponent); Override;
    Destructor  Destroy; Override;
    Function    Parsed(Const S:String):String;
    Procedure   DefaultHandler(var message); override;
    Property  AsInteger: Integer read GetAsInteger write SetAsInteger;
    Property  AsFloat: Real read GetAsFloat write SetAsFloat;
    Property  AsDate: TDate read GetAsDate write SetAsDate;
    Property  AsTime: TTime read GetAsTime write SetAsTime;
   Published
    property  Alignment: TAlignment read FAlignment write SetAlignment;
    property  AutoSelect;
    property  AutoSize;
    property  BorderStyle;
    Property  Capitalize: Boolean Read FCapitalize write SetCapitalize;
    Property  CharCase;
    Property  Color;
    property  ColorOptionsSet : TColorOptionsSet read FColorOptionsSet write FColorOptionsSet;
    Property  Ctl3D;
    Property  Cursor;
    Property  DragCursor;
    Property  DragMode;
    property  EditType : TTypeEdit read FTypeEdit write FTypeEdit;
    Property  Enabled;
    Property  Font;
    Property  Height;
    Property  HelpContext;
    Property  HideSelection;
    Property  Hint;
    property  HintText:Boolean read FHintText write FHintText;
    Property  Left;
    Property  Mask:String Read FMask Write FMask;
    Property  MaxLength;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    Property  Name;
    Property  OEMConvert;
    Property  ParentColor;
    Property  ParentCtl3D;
    Property  ParentFont;
    Property  ParentShowHint;
    Property  PasswordChar;
    Property  PopupMenu;
    Property  ReadOnly;
    Property  Required:Boolean Read FRequired Write SetRequired;
    Property  ShowHint;
    Property  TabOrder;
    Property  TabStop;
    Property  Tag;
    Property  Text;
    Property  Top;
    Property  ValidChars:String Read FValids Write FValids;
    Property  Visible;
    Property  Width;
    Property  OnChange;
    Property  OnClick;
    Property  OnConvert: TConvert Read FConvert Write FConvert;
    Property  OnDblClick;
    Property  OnDragDrop;
    Property  OnDragOver;
    Property  OnEndDrag;
    property  OnEnter: TNotifyEvent read FOnEnter write FOnEnter;
    Property  OnError: TErrorOccur Read FErrorOccur Write FErrorOccur;
    property  OnExit : TNotifyEvent read FOnExit  write FOnExit;
    Property  OnKeyDown;
    Property  OnKeyPress;
    Property  OnKeyUp;
    Property  OnMask: TMaskForm Read FMaskForm Write FMaskForm;
    Property  OnMouseDown;
    property  OnMouseEnter:TNotifyEvent read FOnMouseEnter write FOnMouseEnter;
    property  OnMouseExit:TNotifyEvent read FOnMouseExit write FOnMouseExit;
    Property  OnMouseMove;
    Property  OnMouseUp;
    Property  OnValidate: TValidate Read FValidate Write FValidate;
  End;

  TPubMaskEdit = Class(TMaskEdit)
   Private
    FValidate     : TValidate;
    FErrorOccur   : TErrorOccur;
    FRequired     : Boolean; {neprazdne pole}
    FOnEnter      : TNotifyEvent;
    FOnExit       : TNotifyEvent;
    FColorOptionsSet:TColorOptionsSet;
    FAcceptEmpty  : Boolean; {neze byt prazdne} {8.8.2001}
    Procedure SetRequired(Value:Boolean);
   protected
    procedure DoEnter; override;
    procedure DoExit ; override;
    procedure CMEnter( Var Message : TCMEnter ); Message CM_ENTER;
    procedure CMExit( Var Message : TCMExit ); Message CM_EXIT;
    procedure CMEnabledChanged( Var Message : TMessage ); Message CM_ENABLEDCHANGED;
    {$IfDef emptymaskrequired}
    procedure KeyPress(var Key: Char); override;
    procedure KeyDown (var Key: Word; Shift: TShiftState); override;
    {$EndIf emptymaskrequired}
   public
    Constructor Create(AOwner : TComponent); Override;
    Destructor  Destroy; Override;
   published
    property  AcceptEmpty: Boolean read FAcceptEmpty write FAcceptEmpty;
    property  AutoSelect;
    property  AutoSize;
    property  BorderStyle;
    Property  CharCase;
    Property  Color;
    property  ColorOptionsSet : TColorOptionsSet read FColorOptionsSet write FColorOptionsSet;
    Property  Ctl3D;
    Property  Cursor;
    Property  DragCursor;
    Property  DragMode;
    Property  EditMask;
    Property  Enabled;
    Property  Font;
    Property  Height;
    Property  HelpContext;
    Property  Hint;
    Property  Left;
    Property  MaxLength;
    Property  Name;
    Property  ParentColor;
    Property  ParentCtl3D;
    Property  ParentFont;
    Property  ParentShowHint;
    Property  PasswordChar;
    Property  PopupMenu;
    Property  ReadOnly;
    Property  Required:Boolean Read FRequired Write SetRequired;
    Property  ShowHint;
    Property  TabOrder;
    Property  TabStop;
    Property  Tag;
    Property  Text;
    Property  Top;
    Property  Visible;
    Property  Width;
    Property  OnChange;
    Property  OnClick;
    Property  OnDblClick;
    Property  OnDragDrop;
    Property  OnDragOver;
    Property  OnEndDrag;
    Property  OnEnter:TNotifyEvent read FOnEnter write FOnEnter;
    Property  OnError: TErrorOccur Read FErrorOccur Write FErrorOccur;
    Property  OnExit: TNotifyEvent read FOnExit  write FOnExit;
    Property  OnKeyDown;
    Property  OnKeyPress;
    Property  OnKeyUp;
    Property  OnMouseDown;
    Property  OnMouseMove;
    Property  OnMouseUp;
    Property  OnValidate: TValidate Read FValidate Write FValidate;
  End;
{$IfDef useRXlibrary}
  TPubCurrencyEdit = Class(TCurrencyEdit)
   Private
    FRequired     : Boolean; {neprazdne pole}
    FOnEnter      : TNotifyEvent;
    FOnExit       : TNotifyEvent;
    FColorOptionsSet:TColorOptionsSet;
    Procedure SetRequired(Value:Boolean);
   protected
    procedure DoEnter; override;
    procedure DoExit ; override;
    procedure CMEnter( Var Message : TCMEnter ); Message CM_ENTER;
    procedure CMExit( Var Message : TCMExit ); Message CM_EXIT;
    procedure CMEnabledChanged( Var Message : TMessage ); Message CM_ENABLEDCHANGED;
   public
    Constructor Create(AOwner : TComponent); Override;
    Destructor  Destroy; Override;
   published
    property  Alignment;
    property  AutoSelect;
    property  AutoSize;
    property  BeepOnError;
    property  BorderStyle;
    property  CheckOnExit;
    Property  Color;
    property  ColorOptionsSet : TColorOptionsSet read FColorOptionsSet write FColorOptionsSet;
    Property  Ctl3D;
    Property  Cursor;
    property  DecimalPlaces;
    property  DisplayFormat;
    Property  DragCursor;
    Property  DragMode;
    Property  Enabled;
    Property  Font;
    property  FormatOnEditing;
    Property  Height;
    Property  HelpContext;
    property  HideSelection;
    Property  Hint;
    Property  Left;
    Property  MaxLength;
    property  MaxValue;
    property  MinValue;
    Property  Name;
    Property  ParentColor;
    Property  ParentCtl3D;
    Property  ParentFont;
    Property  ParentShowHint;
    Property  PopupMenu;
    Property  ReadOnly;
    Property  Required:Boolean Read FRequired Write SetRequired;
    Property  ShowHint;
    Property  TabOrder;
    Property  TabStop;
    Property  Tag;
    Property  Text;
    Property  Top;
    property  Value;
    Property  Visible;
    Property  Width;
    property  ZeroEmpty;
    Property  OnChange;
    Property  OnClick;
    Property  OnDblClick;
    Property  OnDragDrop;
    Property  OnDragOver;
    Property  OnEndDrag;
    Property  OnEnter:TNotifyEvent read FOnEnter write FOnEnter;
    Property  OnExit: TNotifyEvent read FOnExit  write FOnExit;
    Property  OnKeyDown;
    Property  OnKeyPress;
    Property  OnKeyUp;
    Property  OnMouseDown;
    Property  OnMouseMove;
    Property  OnMouseUp;
  End;
{$EndIf useRXlibrary}
  TPubComboBox= Class(TComboBox)
   Private
    FErrorOccur   : TErrorOccur;
    FRequired     : Boolean; {neprazdne pole}
    FOnEnter      : TNotifyEvent;
    FOnExit       : TNotifyEvent;
    FColorOptionsSet:TColorOptionsSet;
    FOnListPick: TNotifyEvent;
    Procedure SetRequired(Value:Boolean);
   protected
    procedure ListPick; dynamic;
    procedure DoEnter; override;
    procedure DoExit ; override;
    procedure CMEnter( Var Message : TCMEnter ); Message CM_ENTER;
    procedure CMExit( Var Message : TCMExit ); Message CM_EXIT;
    procedure CMEnabledChanged( Var Message : TMessage ); Message CM_ENABLEDCHANGED;
    procedure CNCommand(var Message: TWMCommand); message CN_COMMAND;
   public
    Constructor Create(AOwner : TComponent); Override;
    Destructor  Destroy; Override;
   published
    Property  Color;
    property  ColorOptionsSet : TColorOptionsSet read FColorOptionsSet write FColorOptionsSet;
    Property  Ctl3D;
    Property  Cursor;
    Property  DragCursor;
    Property  DragMode;
    Property  DropDownCount;
    Property  Enabled;
    Property  Font;
    Property  Height;
    Property  HelpContext;
    Property  Hint;
    Property  ItemHeight;
    Property  Items;
    Property  Left;
    Property  MaxLength;
    Property  Name;
    Property  ParentColor;
    Property  ParentCtl3D;
    Property  ParentFont;
    Property  ParentShowHint;
    Property  PopupMenu;
    Property  Required:Boolean Read FRequired Write SetRequired;
    Property  ShowHint;
    Property  Sorted;
    Property  Style;
    Property  TabOrder;
    Property  TabStop;
    Property  Tag;
    Property  Text;
    Property  Top;
    Property  Visible;
    Property  Width;
    Property  OnChange;
    Property  OnClick;
    Property  OnDblClick;
    Property  OnDragDrop;
    Property  OnDragOver;
    Property  OnDrawItem;
    Property  OnDropDown;
    Property  OnEndDrag;
    Property  OnEnter:TNotifyEvent read FOnEnter write FOnEnter;
    Property  OnError: TErrorOccur Read FErrorOccur Write FErrorOccur;
    Property  OnExit: TNotifyEvent read FOnExit  write FOnExit;
    Property  OnKeyDown;
    Property  OnKeyPress;
    Property  OnKeyUp;
    property  OnListPick: TNotifyEvent read FOnListPick write FOnListPick;
    Property  OnMeasureItem;
  End;
{$IfDef useRXlibrary}
  TPubDateEdit = Class(TDateEdit)
   Private
    FRequired     : Boolean; {neprazdne pole}
    FOnEnter      : TNotifyEvent;
    FOnExit       : TNotifyEvent;
    FColorOptionsSet:TColorOptionsSet;
    Procedure SetRequired(Value:Boolean);
   protected
    procedure DoEnter; override;
    procedure DoExit ; override;
    procedure CMEnter( Var Message : TCMEnter ); Message CM_ENTER;
    procedure CMExit( Var Message : TCMExit ); Message CM_EXIT;
    procedure CMEnabledChanged( Var Message : TMessage ); Message CM_ENABLEDCHANGED;
   public
    Constructor Create(AOwner : TComponent); Override;
    Destructor  Destroy; Override;
   published
    property  AutoSelect;
    Property  BlanksChar;
    property  BorderStyle;
    Property  ButtonHint;
    Property  ButtonWidth;
    Property  CalendarHints;
    Property  CalendarStyle;
    property  CheckOnExit;
    Property  Color;
    property  ColorOptionsSet : TColorOptionsSet read FColorOptionsSet write FColorOptionsSet;
    Property  Ctl3D;
    Property  Cursor;
    Property  DefaultToday;
    Property  DialogTitle;
    Property  DirectInput;
    Property  DragCursor;
    Property  DragMode;
    Property  Enabled;
    Property  Font;
    Property  Glyph;
    Property  Height;
    Property  HelpContext;
    property  HideSelection;
    Property  Hint;
    Property  Left;
    Property  MaxLength;
    Property  Name;
    Property  NumGlyphs;
    Property  ParentColor;
    Property  ParentCtl3D;
    Property  ParentFont;
    Property  ParentShowHint;
    Property  PopupAlign;
    Property  PopupColor;
    Property  PopupMenu;
    Property  ReadOnly;
    Property  Required:Boolean Read FRequired Write SetRequired;
    Property  ShowHint;
    Property  StartOfWeek;
    Property  TabOrder;
    Property  TabStop;
    Property  Tag;
    Property  Text;
    Property  Top;
    Property  Visible;
    Property  WeekendColor;
    Property  Weekends;
    Property  Width;
    Property  YearDigits;
    Property  OnAcceptDate;
    Property  OnButtonClick;
    Property  OnChange;
    Property  OnClick;
    Property  OnDblClick;
    Property  OnDragDrop;
    Property  OnDragOver;
    Property  OnEndDrag;
    Property  OnEnter:TNotifyEvent read FOnEnter write FOnEnter;
    Property  OnExit: TNotifyEvent read FOnExit  write FOnExit;
    Property  OnKeyDown;
    Property  OnKeyPress;
    Property  OnKeyUp;
    Property  OnMouseDown;
    Property  OnMouseMove;
    Property  OnMouseUp;
  End;

  TPubFilenameEdit= Class(TFilenameEdit)
   Private
    FRequired     : Boolean; {neprazdne pole}
    FOnEnter      : TNotifyEvent;
    FOnExit       : TNotifyEvent;
    FColorOptionsSet:TColorOptionsSet;
    Procedure SetRequired(Value:Boolean);
   protected
    procedure DoEnter; override;
    procedure DoExit ; override;
    procedure CMEnter( Var Message : TCMEnter ); Message CM_ENTER;
    procedure CMExit( Var Message : TCMExit ); Message CM_EXIT;
    procedure CMEnabledChanged( Var Message : TMessage ); Message CM_ENABLEDCHANGED;
   public
    Constructor Create(AOwner : TComponent); Override;
    Destructor  Destroy; Override;
   published
    Property  AcceptFiles;
    property  AutoSelect;
    property  BorderStyle;
    Property  ButtonHint;
    Property  ButtonWidth;
    Property  CharCase;
    Property  ClickKey;
    Property  Color;
    property  ColorOptionsSet : TColorOptionsSet read FColorOptionsSet write FColorOptionsSet;
    Property  Ctl3D;
    Property  Cursor;
    Property  DefaultExt;
    Property  DialogKind;
    Property  DialogOptions;
    Property  DialogTitle;
    Property  DirectInput;
    Property  DragCursor;
    Property  DragMode;
    Property  EditMask;
    Property  Enabled;
    Property  FileEditStyle;
    Property  FileName;
    Property  Filter;
    Property  FilterIndex;
    Property  Font;
    Property  Glyph;
    Property  GlyphKind;
    Property  Height;
    Property  HelpContext;
    property  HideSelection;
    Property  Hint;
    Property  HistoryList;
    Property  InitialDir;
    Property  Left;
    Property  Name;
    Property  NumGlyphs;
    Property  ParentColor;
    Property  ParentCtl3D;
    Property  ParentFont;
    Property  ParentShowHint;
    Property  PopupMenu;
    Property  ReadOnly;
    Property  Required:Boolean Read FRequired Write SetRequired;
    Property  ShowHint;
    Property  TabOrder;
    Property  TabStop;
    Property  Tag;
    Property  Text;
    Property  Top;
    Property  Visible;
    Property  Width;
    Property  OnAfterDialog;
    Property  OnBeforeDialog;
    Property  OnButtonClick;
    Property  OnChange;
    Property  OnClick;
    Property  OnDblClick;
    Property  OnDragDrop;
    Property  OnDragOver;
    Property  OnDropFiles;
    Property  OnEndDrag;
    Property  OnEnter:TNotifyEvent read FOnEnter write FOnEnter;
    Property  OnExit: TNotifyEvent read FOnExit  write FOnExit;
    Property  OnKeyDown;
    Property  OnKeyPress;
    Property  OnKeyUp;
    Property  OnMouseDown;
    Property  OnMouseMove;
    Property  OnMouseUp;
  End;

  TPubDirectoryEdit= Class(TDirectoryEdit)
   Private
    FRequired     : Boolean; {neprazdne pole}
    FOnEnter      : TNotifyEvent;
    FOnExit       : TNotifyEvent;
    FColorOptionsSet:TColorOptionsSet;
    Procedure SetRequired(Value:Boolean);
   protected
    procedure DoEnter; override;
    procedure DoExit ; override;
    procedure CMEnter( Var Message : TCMEnter ); Message CM_ENTER;
    procedure CMExit( Var Message : TCMExit ); Message CM_EXIT;
    procedure CMEnabledChanged( Var Message : TMessage ); Message CM_ENABLEDCHANGED;
   public
    Constructor Create(AOwner : TComponent); Override;
    Destructor  Destroy; Override;
   published
    Property  AcceptFiles;
    property  AutoSelect;
    property  BorderStyle;
    Property  ButtonHint;
    Property  ButtonWidth;
    Property  CharCase;
    Property  ClickKey;
    Property  Color;
    property  ColorOptionsSet : TColorOptionsSet read FColorOptionsSet write FColorOptionsSet;
    Property  Ctl3D;
    Property  Cursor;
    Property  DialogOptions;
    Property  DirectInput;
    Property  DragCursor;
    Property  DragMode;
    Property  EditMask;
    Property  Enabled;
    Property  Font;
    Property  Glyph;
    Property  GlyphKind;
    Property  Height;
    Property  HelpContext;
    property  HideSelection;
    Property  Hint;
    Property  InitialDir;
    Property  Left;
    Property  MultipleDirs;
    Property  Name;
    Property  NumGlyphs;
    Property  ParentColor;
    Property  ParentCtl3D;
    Property  ParentFont;
    Property  ParentShowHint;
    Property  PopupMenu;
    Property  ReadOnly;
    Property  Required:Boolean Read FRequired Write SetRequired;
    Property  ShowHint;
    Property  TabOrder;
    Property  TabStop;
    Property  Tag;
    Property  Text;
    Property  Top;
    Property  Visible;
    Property  Width;
    Property  OnAfterDialog;
    Property  OnBeforeDialog;
    Property  OnButtonClick;
    Property  OnChange;
    Property  OnClick;
    Property  OnDblClick;
    Property  OnDragDrop;
    Property  OnDragOver;
    Property  OnDropFiles;
    Property  OnEndDrag;
    Property  OnEnter:TNotifyEvent read FOnEnter write FOnEnter;
    Property  OnExit: TNotifyEvent read FOnExit  write FOnExit;
    Property  OnKeyDown;
    Property  OnKeyPress;
    Property  OnKeyUp;
    Property  OnMouseDown;
    Property  OnMouseMove;
    Property  OnMouseUp;
  End;

  TPubRxCalcEdit= Class(TRxCalcEdit)
   Private
    FRequired     : Boolean; {neprazdne pole}
    FOnEnter      : TNotifyEvent;
    FOnExit       : TNotifyEvent;
    FColorOptionsSet:TColorOptionsSet;
    Procedure SetRequired(Value:Boolean);
   protected
    procedure DoEnter; override;
    procedure DoExit ; override;
    procedure CMEnter( Var Message : TCMEnter ); Message CM_ENTER;
    procedure CMExit( Var Message : TCMExit ); Message CM_EXIT;
    procedure CMEnabledChanged( Var Message : TMessage ); Message CM_ENABLEDCHANGED;
   public
    Constructor Create(AOwner : TComponent); Override;
    Destructor  Destroy; Override;
   published
    Property  Alignment;
    property  AutoSelect;
    Property  AutoSize;
    Property  BeepOnError;
    property  BorderStyle;
    Property  ButtonHint;
    Property  ButtonWidth;
    Property  CheckOnExit;
    Property  ClickKey;
    Property  Color;
    property  ColorOptionsSet : TColorOptionsSet read FColorOptionsSet write FColorOptionsSet;
    Property  Ctl3D;
    Property  Cursor;
    Property  DecimalPlaces;
    Property  DirectInput;
    Property  DisplayFormat;
    Property  DragCursor;
    Property  DragMode;
    Property  Enabled;
    Property  Font;
    Property  FormatOnEditing;
    Property  Glyph;
    Property  GlyphKind;
    Property  Height;
    Property  HelpContext;
    property  HideSelection;
    Property  Hint;
    Property  Left;
    Property  MaxLength;
    Property  MaxValue;
    Property  MinValue;
    Property  Name;
    Property  NumGlyphs;
    Property  ParentColor;
    Property  ParentCtl3D;
    Property  ParentFont;
    Property  ParentShowHint;
    Property  PopupMenu;
    Property  ReadOnly;
    Property  Required:Boolean Read FRequired Write SetRequired;
    Property  ShowHint;
    Property  TabOrder;
    Property  TabStop;
    Property  Tag;
    Property  Text;
    Property  Top;
    Property  Value;
    Property  Visible;
    Property  Width;
    Property  ZeroEmpty;
    Property  OnButtonClick;
    Property  OnChange;
    Property  OnClick;
    Property  OnDblClick;
    Property  OnDragDrop;
    Property  OnDragOver;
    Property  OnEndDrag;
    Property  OnEnter:TNotifyEvent read FOnEnter write FOnEnter;
    Property  OnExit: TNotifyEvent read FOnExit  write FOnExit;
    Property  OnKeyDown;
    Property  OnKeyPress;
    Property  OnKeyUp;
    Property  OnMouseDown;
    Property  OnMouseMove;
    Property  OnMouseUp;
  End;

  TPubComboEdit= Class(TComboEdit)
   Private
    FValidate     : TValidate;
    FConvert      : TConvert;
    FErrorOccur   : TErrorOccur;
    FMaskForm     : TMaskForm;
    FRequired     : Boolean; {neprazdne pole}
    FCapitalize   : Boolean; {prvni znaky slov velke}
    FOnEnter      : TNotifyEvent;
    FOnExit       : TNotifyEvent;
    FValids       : String;  {platne znaky napr. 'abcABC'}
    FMask         : String;  {maska napriklad 'XX.XX.XX/XX-XX'}
    FColorOptionsSet:TColorOptionsSet;
    Procedure SetRequired(Value:Boolean);
   protected
    Procedure SetCapitalize(Value:Boolean);
    procedure KeyPress(var Key: Char); Override;
    procedure DoEnter; override;
    procedure DoExit ; override;
    procedure CMEnter( Var Message : TCMEnter ); Message CM_ENTER;
    procedure CMExit( Var Message : TCMExit ); Message CM_EXIT;
    procedure CMEnabledChanged( Var Message : TMessage ); Message CM_ENABLEDCHANGED;
   public
    Constructor Create(AOwner : TComponent); Override;
    Destructor  Destroy; Override;
   published
    Property  Alignment;
    property  AutoSelect;
    property  BorderStyle;
    Property  ButtonHint;
    Property  ButtonWidth;
    Property  Capitalize: Boolean Read FCapitalize write SetCapitalize;
    Property  CharCase;
    Property  ClickKey;
    Property  Color;
    property  ColorOptionsSet : TColorOptionsSet read FColorOptionsSet write FColorOptionsSet;
    Property  Ctl3D;
    Property  Cursor;
    Property  DirectInput;
    Property  DragCursor;
    Property  DragMode;
    Property  EditMask;
    Property  Enabled;
    Property  Font;
    Property  Glyph;
    Property  GlyphKind;
    Property  Height;
    Property  HelpContext;
    property  HideSelection;
    Property  Hint;
    Property  Left;
    Property  MaxLength;
    Property  Name;
    Property  NumGlyphs;
    Property  OEMConvert;
    Property  ParentColor;
    Property  ParentCtl3D;
    Property  ParentFont;
    Property  ParentShowHint;
    Property  PopupMenu;
    Property  ReadOnly;
    Property  Required:Boolean Read FRequired Write SetRequired;
    Property  ShowHint;
    Property  TabOrder;
    Property  TabStop;
    Property  Tag;
    Property  Text;
    Property  Top;
    Property  ValidChars:String Read FValids Write FValids;
    Property  Visible;
    Property  Width;
    Property  OnButtonClick;
    Property  OnConvert: TConvert Read FConvert Write FConvert;
    Property  OnChange;
    Property  OnClick;
    Property  OnDblClick;
    Property  OnDragDrop;
    Property  OnDragOver;
    Property  OnEndDrag;
    Property  OnEnter:TNotifyEvent read FOnEnter write FOnEnter;
    Property  OnError: TErrorOccur Read FErrorOccur Write FErrorOccur;
    Property  OnExit: TNotifyEvent read FOnExit  write FOnExit;
    Property  OnKeyDown;
    Property  OnKeyPress;
    Property  OnKeyUp;
    Property  OnMask: TMaskForm Read FMaskForm Write FMaskForm;
    Property  OnMouseDown;
    Property  OnMouseMove;
    Property  OnMouseUp;
    Property  OnValidate: TValidate Read FValidate Write FValidate;
  End;
{$EndIf useRXlibrary}
procedure Register;

Implementation


{$IfDef VER80}
Function TrimLead(S:String):String;
  {-vraci zleva orezany retezec}
Begin
  Result:=S;
  While (Length(Result)>0) And (Result[1] <= ' ') Do Delete(Result,1,1);
End;

Function TrimTrail(S:String):String;
  {-vraci zprava orezany retezec}
Begin
  Result := S;
  While (Length(Result) > 0) And (Result[Length(Result)] <= ' ') Do
    Delete(Result,Length(Result),1);
End;

Function Trim(S:String):String;
  {-vraci z obou stran orezany retezec}
Begin
  Result := TrimLead(TrimTrail(S));
End;
{$EndIf}

constructor TColorOptionsSet.Create;
Begin
  Inherited;
  ColorOnFocus    := clYellow;
  ColorOnFocusFont := clBlack;
  ColorOnNotFocus := clWindow;
  ColorOnNotFocusFont := clBlack;
  ColorOnDisabled := clBtnFace;
  ColorOnDisabledFont := clGrayText;
End;

procedure TPaintLineHintWindow.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  Params.Style := Params.Style and not ws_Border;
end;

procedure TPaintLineHintWindow.Paint;
begin
  inherited {$IfDef VER80}Paint{$EndIf}; {draw the original hint}
  with Canvas do begin  {then, draw a new border}
    Pen.Width := 1;
    Pen.Color := clBtnShadow; {clBlack is the windows default;}
    Polyline([Point(0,0),Point(ClipRect.Right-1,0),
              Point(ClipRect.Right-1,ClipRect.Bottom-1),
              Point(0,ClipRect.Bottom-1),Point(0,0)]);
  end;
end;

procedure TPubEdit.CreateParams(var Params: TCreateParams);
const
  Alignments : array[TAlignment] of Longint = (ES_LEFT, ES_RIGHT, ES_CENTER);
begin
  inherited CreateParams(Params);
  Params.Style := Params.Style or Alignments[FAlignment];
end;

Constructor TPubEdit.Create(AOwner : TComponent);
var
  TheForm: TComponent;       {The form that ultimately owns this component}
Begin
  Inherited Create(AOwner);
  FColorOptionsSet := TColorOptionsSet.Create;
  Color           := ColorOptionsSet.ColorOnNotFocus;
  FTypeEdit       := teString;
  FCapitalize     := False;
  FRequired       := False;
  FValids         := '';
  FMask           := '';
  FAlignMent      := taLeftJustify;
  {}
  HintWin := TPaintLineHintWindow.Create(Self);
  HintWin.Color := {$IfDef VER80}clYellow{$Else}clInfoBk{$EndIf};
  HintWin.Canvas.Font.Color := {$IfDef VER80}clBlack{$Else}clInfoText{$EndIf};
  {Check if owner is a form, if not, move up tree of owners until we either find a form or a nil reference}
  TheForm := AOwner;
  while (TheForm <> nil) and not (TheForm is TForm) do TheForm := TheForm.Owner;
  {Record form window reference appropriately}
  if TheForm <> nil then FWindow := TheForm as TForm else FWindow := nil;
End;

procedure TPubEdit.DefaultHandler(var message);
var
  MsgT: TMsg;
begin
  {convert message to TMsg}
  MsgT.message := TMessage(message).Msg;
  inherited {$IfDef VER80}DefaultHandler(message){$EndIf};
  if HintWin = nil then Exit;
  {if it's WM_Mousemove then we don't want to hide the hint window}
  if (HintWin.IsHintMsg(MsgT) and (MsgT.message <> WM_MouseMove)) then
    ReleaseIt;
end;

Destructor TPubEdit.Destroy;
Begin
  FColorOptionsSet.Free;
  Inherited Destroy;
End;

procedure TPubEdit.SetAlignment(Value: TAlignment);
begin
  if FAlignment <> Value then
  begin
    FAlignment := Value;
    RecreateWnd;
  end;
end;

Procedure TPubEdit.SetRequired(Value:Boolean);
Begin
  If Value <> FRequired Then
    FRequired := Value;
End;

Procedure TPubEdit.SetCapitalize(Value:Boolean);
Begin
  If Value <> FCapitalize Then
    FCapitalize := Value;
End;

Procedure TPubEdit.SetAsInteger(Value: Integer);
Begin
  Text := IntToStr(Value)
End;

Function TPubEdit.GetAsInteger: Integer;
Begin
  Try
    Result := StrToInt(Text);
  Except
    Result := 0;
  End
End;

Procedure TPubEdit.SetAsFloat(Value: Real);
Begin
  Text := FloatToStr(Value);
End;

Function TPubEdit.GetAsFloat: Real;
Begin
  Try
    Result := StrToFloat(Text);
  Except
    Result := 0;
  End
End;

Procedure TPubEdit.SetAsDate(Value: TDate);
Begin
  Text := DateToStr(Value);
End;

Function TPubEdit.GetAsDate: TDate;
Begin
  Try
    Result := StrToDate(Text);
  Except
    Result := 0;
  End
End;

Procedure TPubEdit.SetAsTime(Value: TTime);
Begin
  Text := TimeToStr(Value);
End;

Function TPubEdit.GetAsTime: TTime;
Begin
  Try
    Result := StrToTime(Text);
  Except
    Result := 0;
  End
End;

Const
  ccControlKeys=[#8{vk_TAB},#22{ctrl+V},#3{ctrl+C},#24{ctrl+X}];

Procedure TPubEdit.KeyPress(var Key: Char);
Var
 C: String;
 VCH: Set Of Char;
 I: Integer;
Begin
  Case FTypeEdit of
   teString:
    Begin
      {nejprve vyrob mnozinu znaku}
      VCH := [];
      If Length(FValids) > 0 Then
        For I := 1 To Length(FValids) Do
          Include(VCH,Chr(Ord(FValids[I])));
      {ohodnot}
      If (NOT (Key in ccControlKeys)) And (VCH <> []) Then
        If Not (Key In VCH) Then Key := #0; {Delej, jako by nebyla}

    End;

  {pro vstup cisel se predpoklada interne jina maska}
   teInteg:
    Begin
      {nejprve vyrob mnozinu znaku}
      VCH := ['0'..'9','+','-'];
      {ohodnot}
      If (NOT (Key in ccControlKeys)) And (VCH <> []) Then
        If Not (Key In VCH) Then Key := #0; {Delej, jako by nebyla}
    End;

  {pro vstup cisel se predpoklada interne jina maska}
   teFloat:
    Begin
      {nejprve vyrob mnozinu znaku}
      VCH := ['0'..'9','+','-','.',',','e','E'];
      {ohodnot}
      If (NOT (Key in ccControlKeys)) And (VCH <> []) Then
        If Not (Key In VCH) Then Key := #0; {Delej, jako by nebyla}
    End;

  End {case};
  {jsou-li pozadovana velka pismena na zacatku slov, udelej to tady}
  If FCapitalize Then
    If (SelStart = 0) Or (Text[SelStart] = ' ') Then
    Begin
      C := Key;
      C := AnsiUpperCase(C);
      Key := C[1];
    End;

  If Key <> #0 Then
    Inherited KeyPress(Key);
End;

Procedure TPubEdit.DoEnter;
Var S:String;
Begin
  {vybarvi pole pri zamereni}
  Color := ColorOptionsSet.ColorOnFocus;
  Font.Color := ColorOptionsSet.ColorOnFocusFont;

  Case FTypeEdit of
  {je-li pozadovano prevedeni a jedna-li se o integ cislo}
    teInteg:
      If AsSigned(FConvert) Then Begin{je-li prislusna rutina}
        S:=Text;
        FConvert(Self,eValueToText,S); {preved text na jiny format}
        Text:=S;
      End;

  {je-li potreba zaformatovat podle masky, pak jenom pro string}
    teString:
      If AsSigned(FMaskForm) Then Begin
        S := Text;
        FMaskForm(Self,eValueToText,FMask,S);
        Text := S;
      End;

  End {case};

  if not AutoSelect then
    If Text='' Then SelStart := 0
    Else SelStart := GetTextLen;

  If Assigned(FOnEnter) Then
    FOnEnter(Self);
End;

Procedure TPubEdit.DoExit;
Var
  S: String;
  Err: Boolean;
Begin
  {tady zmen barvu pole, kdyz ztracis zamereni}
  Color := ColorOptionsSet.ColorOnNotFocus;
  Font.Color := ColorOptionsSet.ColorOnNotFocusFont;
  self.Repaint;
  Err:=False;
  Case FTypeEdit Of
    teInteg: If Text <> '' Then Begin
      {je-li ocekavano cislo, pak to cislo byt musi}
      Try
        StrToInt(Text); {predpokladam Longint}
      Except
        on EConvertError Do Begin
          Err:=True;
          If AsSigned(FErrorOccur) Then
            {uzivatelska reakce na chybu}
            FErrorOccur(Self,msgNoIntegerValue)
          Else
            MessageDlg(msgNoIntegerValue,mtError, [mbOK],0);
          Self.SetFocus;
        End;
      End;
      {je-li pozadovano prevedeni a jedna-li se o integ cislo}
      If Not Err And AsSigned(FConvert) Then Begin{je-li prislusna rutina}
        S := Text;
        FConvert(Self,eTextToValue,S); {preved text na jiny format}
        Text := S;
      End;
    End;
    teFloat: If Text <> '' Then Begin
      {je-li ocekavano cislo, pak to cislo byt musi}
      Try
          StrToFloat(Text); {nejaky float}
        Except
          on EConvertError Do Begin
            If AsSigned(FErrorOccur) Then
              {uzivatelska reakce na chybu}
              FErrorOccur(Self,msgNoFloatValue)
            Else
              MessageDlg(msgNoFloatValue,mtError, [mbOK],0);
            Self.SetFocus;
          End;
        End;
    End;
    teString:If Text <> '' Then Begin
      {je-li maska (ale i bez ni), pak formatuj externi rutinou}
      If AsSigned(FMaskForm) Then Begin
        S := Text;
        FMaskForm(Self,eTextToValue,FMask,S);
        Text := S;
      End;
    End;
  End {case};

  {tohle je vlastni onexit}
  If Assigned(FOnExit) Then FOnExit(Self);

  {teprve po nem znovu overuji, zda je pole vyplneno dle pozadavku}
  If FRequired And (Text = '') Then Begin
    If AsSigned(FErrorOccur) Then
      {uzivatelska reakce na chybu}
      FErrorOccur(Self,msgFieldRequired)
    Else
      MessageDlg(msgFieldRequired,mtWarning, [mbOK],0);
    SetFocus;
  End;

End;

Procedure TPubEdit.CMExit( Var Message : TCMExit );
Var
  CanExit: Boolean;
  S:String;
Begin
  Inherited;
  {je-li pozadovano polozku vyplnit a ona je prazdna, pak znovu}
  {tady zadnou hlasku nezobrazuji}
  If FRequired And (Text='') Then Begin
    MessageBeep($ffff);
    Self.SetFocus;
    Exit;
  End;
  {je-li pozadovana externi validace a neprojde, pak taky znovu}
  If FTypeEdit<>teParser Then Begin
    If Assigned(FValidate) Then Begin
      S := Text;{<-- text z editu}       {zmena maskovani 01.09.1999 J.B.}
      {pole nejlepe bez masek}
      If AsSigned(FMaskForm) Then
        FMaskForm(Self,eValueToText,Mask,S);
      Try
        {Vlastni validace}
        FValidate(Self, S, CanExit);
      Finally                       {fixed 23.10.2001 J.B.}
        If AsSigned(FMaskForm) Then FMaskForm(Self,eTextToValue,Mask,S);
      End;
      {Oprava textu zde}
      If Text <> S Then {27.7.2001 J.B.}
        Text := S;
      {pri chybe zpet}
      If Not CanExit Then Begin
        MessageBeep($ffff); {pri chybe jenom pipni}
        (*If AsSigned(FErrorOccur) Then
          {uzivatelska reakce na chybu}
          FErrorOccur(Self,msgFieldInvalidate)
        Else
          MessageDlg(msgFieldInvalidate,mtWarning, [mbOK],0);*)
        Self.SetFocus;
        Exit;
      End;
    End;
  End
  Else
    {pro parser je validace extra zde}
    Text:=Parsed(Text);
End;

Procedure TPubEdit.CMEnter( Var Message : TCMEnter );
Begin
  Inherited;
End;

procedure TPubEdit.CMMouseEnter(var message: TMessage);
begin
  inherited;
  if Assigned(FOnMouseEnter) then fonmouseenter(Self);
end;

procedure TPubEdit.CMMouseLeave(var message: TMessage);
begin
  inherited;
  ReleaseIt;
  If Assigned(FOnMouseExit) then fonmouseexit(Self);
end;

Procedure TPubEdit.CMEnabledChanged( Var Message : TMessage);
Begin
  Inherited;
  {obzvlast zajimave, nastavuji barvy :-( }
  If Enabled Then
    If Focused Then
    Begin
      Color := ColorOptionsSet.ColorOnFocus;
      Font.Color := ColorOptionsSet.ColorOnFocusFont;
    End
    Else
    Begin
      Color := ColorOptionsSet.ColorOnNotFocus;
      Font.Color := ColorOptionsSet.ColorOnNotFocusFont;
    End
  Else
  Begin
    Color := ColorOptionsSet.ColorOnDisabled;
    Font.Color := ColorOptionsSet.ColorOnDisabledFont;
  End
End;

procedure TPubEdit.MouseUp(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
  if FSelectAll and FWider and Focused then begin
    SelectAll;
    FSelectAll := False;
  end;
  inherited {$IfDef VER80}MouseUp(Button,Shift,X,Y){$EndIf};
end;

{-----------------------------------------------------------------------------}
procedure TPubEdit.MouseMove(Shift: TShiftState; X, Y: Integer);
{ Since this was originally coded for a TListBox, where it makes sense being
  this way, and here it was adapted for a TEdit component, I think this could
  be better off inside the OnEnter event, but, since I'm naturally born lazy,
  I made only the minor modifications needed.  Someone can surely do a better
  job... }
var
  Rct: TRect;
begin
  if FWider and not Focused then begin
    FSelectAll := True;
    FWider := False;
  end;

  if not(HintText) then begin  {Item hinting is off}
    ReleaseIt;
    inherited {$IfDef VER80}MouseMove(Shift, X, Y){$EndIf};
    Exit;
  end;

  { Check if there is an owning window - get out if not}
  { If HintEdit is focused, do not show the tooltip to let user edit it}
  { Also, if Application has no focus, why should we care about showing a tip?}
  if Focused or (FWindow = nil) or (Trim(Text) = '') or
    not Application.Active then Exit;

  { the line that follows is important, otherwise the next line will calculate}
  { the wrong TextWidth via FWindows' Canvas - Thanks Peter Below (TeamB),}
  { for this handy tip that I found in Borland Newsgroup}
  FWindow.Canvas.Font := Font;
  { Check if the Text is wider then the Width}
  if FWindow.Canvas.TextWidth(Text) > Width - 6 then begin
    FWider := True;
    if FShowing then Exit;
    { Get the default item coordinates}
    Rct := ClientRect;
    { Stretch it to fit the whole edit text }
    Rct.Right := Rct.Left + FWindow.Canvas.TextWidth(Text) + 5;
    { Fine tune theses values for appearance }
    Rct.Top := Rct.Top - 1;{2}
    Rct.Bottom := Rct.Bottom - 4;{2}
    Rct.Left := Rct.Left - 1;{2}
    { now convert to screen coordinates so that THintWindow can use them}
    Rct.TopLeft := ClientToScreen(Rct.TopLeft);
    Rct.BottomRight := ClientToScreen(Rct.BottomRight);
    { And show it!}
    HintWin.ActivateHint(Rct, Text);
    FShowing := True;
  end
  else
    ReleaseIt;

  inherited {$IfDef VER80}MouseMove(Shift, X, Y){$EndIf};
end;

procedure TPubEdit.ReleaseIt;
begin
  HintWin.ReleaseHandle;
  FShowing := False;
end;

Function TPubEdit.Parsed(Const S:String):String;

Const  EnableOpcode:string=('+-*/^');

  Function Evaluate(S:string):Extended;forward;

  Procedure MatchBracket(Var I:Integer;S:string);
  Var
    J,len:Integer;
  Begin
    If (Pos('(',S)=0) And (Pos(')',S)=0) Then Exit;
    J := 1;
    len := Length(S);
    Repeat
      Inc(i);
      If i > len Then
        Raise EvaluatorError.Create(msgMissingRBracket);
      If S[i]='(' Then Inc(j);
      If S[i]=')' Then Dec(j);
      If j<0 Then
        If AsSigned(FErrorOccur) Then
          {uzivatelska reakce na chybu}
          FErrorOccur(Self,msgMissingLBracket)
        Else
          Raise EvaluatorError.Create(msgMissingLBracket);
    Until j = 0;
  End;

  Function GetValue(S:String):extended;
  Begin
    Result:=0;
    If length(S) < 1 Then
      If AsSigned(FErrorOccur) Then
        {uzivatelska reakce na chybu}
        FErrorOccur(Self,msgSyntaxError)
      Else
        Raise EvaluatorError.Create(msgSyntaxError);
    Try
    If Length(S) = 1 Then
      Result := StrToFloat(S)
    Else
      Result := StrToFloat(S);
    Except
      on EConvertError Do Begin
        If AsSigned(FErrorOccur) Then
          {uzivatelska reakce na chybu}
          FErrorOccur(Self,msgNoFloatValue)
        Else
          Raise EvaluatorError.Create(msgNoFloatValue);
      End;
    End;
  End;

  Function SpecialFn(p1:Integer;S:String):Extended;
  Var
    operstr:String;
    arg:Extended;
  Begin
    Result:=0;
    operstr:=Copy(S,1,p1-1);
    If S[Length(S)] <> ')' Then
      If AsSigned(FErrorOccur) Then
        {uzivatelska reakce na chybu}
        FErrorOccur(Self,Format(msgSyntaxError+' %s',[S]))
      Else
        EvaluatorError.CreateFmt(msgSyntaxError+' %s',[S]);
    arg:=Evaluate(copy(S,p1+1,length(S)-p1-1));
    If operstr ='sin' Then Result:=sin(arg)
    Else
      If operstr ='cos' Then Result:=cos(arg)
      Else
        If operstr ='tan' Then Result:=sin(arg)/cos(arg)
        Else
          If operstr ='arctan' Then Result:=arctan(arg)
          Else
            If operstr ='log' Then Result:=ln(arg)/ln(10)
            Else
              If operstr ='ln' Then Result:=ln(arg)
              Else
                If operstr ='exp' Then Result:=exp(arg)
                Else
                  If operstr ='sqrt' Then result:=sqrt(arg)
                  {tady se daji pridat dalsi funkce}
                  Else Begin
                    If AsSigned(FErrorOccur) Then
                      {uzivatelska reakce na chybu}
                      FErrorOccur(Self,Format(msgUnknownFnc+' %s',[S]))
                    Else
                      Raise EvaluatorError.CreateFmt(msgUnknownFnc+' %s',[S]);
                  End
  End;

  Function Calculate(p1:Integer;S:String):Extended;
  Var
    v1,v2:Extended;
  Begin
    Result:=0;
    v1:=Evaluate(Copy(S,1,p1-1));
    v2:=Evaluate(Copy(S,p1+1,Length(S)-p1));
    Case S[p1] Of
      '+': result:=v1+v2;
       '-': result:=v1-v2;
       '/': result:=v1/v2;
       '*': result:=v1*v2;
       '^': result:=exp(v2*ln(v1));
    Else
      If AsSigned(FErrorOccur) Then
        {uzivatelska reakce na chybu}
        FErrorOccur(Self,Format(msgInvalidOperation+' %s',[S]))
      Else
        raise EparserError.CreateFmt(msgInvalidOperation+' %s',[S]);
    End;
  End;

  Function GetFirstOpp(tot:Integer;S:String):Integer;
  Var
    i:Integer;
  Begin
    If tot=0 Then tot := Length(S);
    For i := 1 To 5 Do Begin
      Result := Pos(EnableOpcode[i],S);
      If ((i<3) And (Result>0)) Then
        If ((Result=1) Or (Pos(S[Result-1],EnableOpcode)>0)) Then Result := 0;
      If result>0 Then
        If result<tot Then exit;
    End;
    If Result>tot Then Result:=0;
  End;

  Function Evaluate(S:string):Extended;
  Var
    p1,p2,q1:integer;
  Begin
    p1:=Pos('(',S);
    p2:=p1;
    If p2>0 Then matchbracket(p2,S);
    If p1=1 Then Begin
      If p2=Length(S) Then Begin
        Delete(S,p2,1);
        Delete(S,1,1);
        Result:=Evaluate(S);
      End
      Else
        Result:=Calculate(p2+1,S);
      Exit;
    End;
    q1:=GetFirstOpp(p1,S);
    If (p1+q1=0) Then Begin
      Result:=GetValue(S);
      Exit;
    End;
    If q1<>0 Then
      Result:=Calculate(q1,S)
    Else
      If Length(S)>p2 Then
        Result:=Calculate(p2+1,S)
      Else
        Result:=SpecialFn(p1,S);
  End;
  Procedure CleanUp(Var S:String);
  Var i:integer;
  Begin
    S:=LowerCase(S); {nepredpokladam cestinu :-))  }
    i:=Pos(' ',S);
    While i>0 Do Begin
      delete(S,i,1);
      i:=pos(' ',S);
    End;
  End;
Var X:String;
Begin
  Result := S;
  If S = '' Then Exit;
  X:=S;
  Try
     CleanUp(X);
     Result:=FloatToStr(Evaluate(X));
  Except
     On E:Exception Do
       If AsSigned(FErrorOccur) Then
         {uzivatelska reakce na chybu}
         FErrorOccur(Self,msgConvertValue+#13+'('+E.Message+')')
       Else
         MessageDlg(msgConvertValue+#13+'('+E.Message+')',mtError, [mbOK],0);
  End;
End;

Procedure TPubEdit.NextControl(YesNo:Boolean);
var
 FTempForm : {$IfNDef Win32}TForm{$Else}
  {$IfDef Ver90}TForm{$Else}TCustomForm{$Endif}{$Endif};
begin

  if YesNo = True then begin
    FTempForm := GetParentForm(Self);
    SendMessage(FTempForm.Handle, WM_NEXTDLGCTL, 0, 0);
  end

end;

{*****************}

Constructor TPubMaskEdit.Create(AOwner : TComponent);
Begin
  Inherited Create(AOwner);
  FColorOptionsSet := TColorOptionsSet.Create;
  Color           := ColorOptionsSet.ColorOnNotFocus;
  FRequired       := False;
  FAcceptEmpty    := False;
End;

Destructor TPubMaskEdit.Destroy;
Begin
  FColorOptionsSet.Free;
  Inherited Destroy;
End;

Procedure TPubMaskEdit.SetRequired(Value:Boolean);
Begin
  If Value <> FRequired Then
    FRequired := Value;
End;

Procedure TPubMaskEdit.DoEnter;
Begin
  {vybarvi pole pri zamereni}
  Color := ColorOptionsSet.ColorOnFocus;
  Font.Color := ColorOptionsSet.ColorOnFocusFont;

  if not AutoSelect then
    If Trim(Text)='' Then SelStart := 0
    Else SelStart := GetTextLen;

  {vlastni funkce onenter}
  If Assigned(FOnEnter) Then
    FOnEnter(Self);
End;

Procedure TPubMaskEdit.DoExit;
Begin
  {tady zmen barvu pole, kdyz ztracis zamereni}
  Color := ColorOptionsSet.ColorOnNotFocus;
  Font.Color := ColorOptionsSet.ColorOnNotFocusFont;

  {tohle je vlastni onexit}
  If Assigned(FOnExit) Then FOnExit(Self);

  {teprve po nem znovu overuji, zda je pole vyplneno dle pozadavku}
  If FRequired And (Text = '') Then Begin
    If AsSigned(FErrorOccur) Then
      {uzivatelska reakce na chybu}
      FErrorOccur(Self,msgFieldRequired)
    Else
      MessageDlg(msgFieldRequired,mtWarning, [mbOK],0);
    SetFocus;
  End;

End;

Procedure TPubMaskEdit.CMExit( Var Message : TCMExit );
Var
  CanExit: Boolean;
  S:String;
  CurValue: String;
  CurMask: String;
Begin
  {tento kod doplnen pro pozadavek prazdneho pole}
  {$IfDef emptymaskrequired}
  CurValue := Text;
  If FAcceptEmpty and ( (Text = FormatMaskText (EditMask, '')) or (Text = '') ) Then
  begin
    CurMask := EditMask;
    EditMask := '';
    try
      inherited;
    except
      Text := CurValue;
      raise;
      Exit;
    end;
    EditMask := CurMask;
    Exit;
  end;
  {$EndIf emptymaskrequired}
  Inherited;
  {je-li pozadovano polozku vyplnit a ona je prazdna, pak znovu}
  {tady zadnou hlasku nezobrazuji}
  If FRequired And (Text='') Then Begin
    MessageBeep($ffff);
    Self.SetFocus;
    Exit; {out without any message}
  End;
  {je-li pozadovana externi validace a neprojde, pak taky znovu}

  If Assigned(FValidate) Then Begin
    S:=Text;
    FValidate(Self, S, CanExit);
    If S<>Text Then {in validate can be changed, update it !}
      Text:=S;
    If Not CanExit Then Begin  {fatal error in validate}
      MessageBeep($ffff);
      Self.SetFocus;
      Exit;
    End;
  End;

End;

{$IfDef emptymaskrequired}
procedure TPubMaskEdit.KeyPress(var Key: Char);
var
  KeptEditMask: String;
begin
  if ( (Key = #13) and FAcceptEmpty and 
    (Trim (Text) = Trim (FormatMaskText (EditMask, ''))) ) then
    try
      KeptEditMask := EditMask;
      EditMask := '';
      inherited KeyPress(Key);
    finally
      EditMask := KeptEditMask;
      Key := #0;
    end
  else
    inherited KeyPress(Key);
end;

procedure TPubMaskEdit.KeyDown (var Key: Word; Shift: TShiftState);
begin
  if ( (ssCtrl in Shift) and (Key = vk_Return) ) then
  begin
    DblClick;
  end;

  inherited KeyDown (Key, Shift);
end;
{$EndIf emptymaskrequired}

Procedure TPubMaskEdit.CMEnter( Var Message : TCMEnter );
Begin
  Inherited;
End;

Procedure TPubMaskEdit.CMEnabledChanged( Var Message : TMessage);
Begin
  Inherited;
  If Enabled Then
    If Focused Then
    Begin
      Color := ColorOptionsSet.ColorOnFocus;
      Font.Color := ColorOptionsSet.ColorOnFocusFont;
    End
    Else
    Begin
      Color := ColorOptionsSet.ColorOnNotFocus;
      Font.Color := ColorOptionsSet.ColorOnNotFocusFont;
    End
  Else
  Begin
    Color := ColorOptionsSet.ColorOnDisabled;
    Font.Color := ColorOptionsSet.ColorOnDisabledFont;
  End
End;

{*****************}
{$IfDef useRXlibrary}
Constructor TPubCurrencyEdit.Create(AOwner : TComponent);
Begin
  Inherited Create(AOwner);
  FColorOptionsSet := TColorOptionsSet.Create;
  Color           := ColorOptionsSet.ColorOnNotFocus;
  FRequired       := False;
End;

Destructor TPubCurrencyEdit.Destroy;
Begin
  FColorOptionsSet.Free;
  Inherited Destroy;
End;

Procedure TPubCurrencyEdit.SetRequired(Value:Boolean);
Begin
  If Value <> FRequired Then
    FRequired := Value;
End;

Procedure TPubCurrencyEdit.DoEnter;
Begin
  {vybarvi pole pri zamereni}
  Color := ColorOptionsSet.ColorOnFocus;
  Font.Color := ColorOptionsSet.ColorOnFocusFont;
  {vlastni funkce onenter}
  If Assigned(FOnEnter) Then
    FOnEnter(Self);
End;

Procedure TPubCurrencyEdit.DoExit;
Begin
  {tady zmen barvu pole, kdyz ztracis zamereni}
  Color := ColorOptionsSet.ColorOnNotFocus;
  Font.Color := ColorOptionsSet.ColorOnNotFocusFont;

  {tohle je vlastni onexit}
  If Assigned(FOnExit) Then FOnExit(Self);

  {teprve po nem znovu overuji, zda je pole vyplneno dle pozadavku}
  If FRequired And (Text = '') Then Begin
    If BeepOnError Then MessageBeep($ffff);
    SetFocus;
  End;

End;

Procedure TPubCurrencyEdit.CMExit( Var Message : TCMExit );
Begin
  Inherited;
  {je-li pozadovano polozku vyplnit a ona je prazdna, pak znovu}
  {tady zadnou hlasku nezobrazuji}
  If FRequired And (Text='') Then Begin
    If BeepOnError Then MessageBeep($ffff);
    Self.SetFocus;
    Exit;
  End;
End;

Procedure TPubCurrencyEdit.CMEnter( Var Message : TCMEnter );
Begin
  Inherited;
End;

Procedure TPubCurrencyEdit.CMEnabledChanged( Var Message : TMessage);
Begin
  Inherited;
  If Enabled Then
    If Focused Then
    Begin
      Color := ColorOptionsSet.ColorOnFocus;
      Font.Color := ColorOptionsSet.ColorOnFocusFont;
    End
    Else
    Begin
      Color := ColorOptionsSet.ColorOnNotFocus;
      Font.Color := ColorOptionsSet.ColorOnNotFocusFont;
    End
  Else
  Begin
    Color := ColorOptionsSet.ColorOnDisabled;
    Font.Color := ColorOptionsSet.ColorOnDisabledFont;
  End
End;
{$EndIf useRXlibrary}
{*****************}

Constructor TPubComboBox.Create(AOwner : TComponent);
Begin
  Inherited Create(AOwner);
  FColorOptionsSet := TColorOptionsSet.Create;
  Color           := ColorOptionsSet.ColorOnNotFocus;
  FRequired       := False;
End;

Destructor TPubComboBox.Destroy;
Begin
  FColorOptionsSet.Free;
  Inherited Destroy;
End;

Procedure TPubComboBox.SetRequired(Value:Boolean);
Begin
  If Value <> FRequired Then
    FRequired := Value;
End;

Procedure TPubComboBox.DoEnter;
Begin
  {vybarvi pole pri zamereni}
  Color := ColorOptionsSet.ColorOnFocus;
  Font.Color := ColorOptionsSet.ColorOnFocusFont;


  {vlastni funkce onenter}
  If Assigned(FOnEnter) Then
    FOnEnter(Self);
End;

Procedure TPubComboBox.DoExit;
Begin
  {tady zmen barvu pole, kdyz ztracis zamereni}
  Color := ColorOptionsSet.ColorOnNotFocus;
  Font.Color := ColorOptionsSet.ColorOnNotFocusFont;

  {tohle je vlastni onexit}
  If Assigned(FOnExit) Then FOnExit(Self);

  {teprve po nem znovu overuji, zda je pole vyplneno dle pozadavku}
  If FRequired And (Text = '') Then Begin
    If AsSigned(FErrorOccur) Then
      {uzivatelska reakce na chybu}
      FErrorOccur(Self,msgFieldRequired)
    Else
      MessageDlg(msgFieldRequired,mtWarning, [mbOK],0);
    SetFocus;
  End;

End;

Procedure TPubComboBox.CMExit( Var Message : TCMExit );
Begin
  Inherited;
  {je-li pozadovano polozku vyplnit a ona je prazdna, pak znovu}
  {tady zadnou hlasku nezobrazuji}
  If FRequired And (Text='') Then Begin
    MessageBeep($ffff);
    Self.SetFocus;
    Exit;
  End;
  {je-li pozadovana externi validace a neprojde, pak taky znovu}
End;

Procedure TPubComboBox.CMEnter( Var Message : TCMEnter );
Begin
  Inherited;
End;

Procedure TPubComboBox.CMEnabledChanged( Var Message : TMessage);
Begin
  Inherited;
  If Enabled Then
    If Focused Then
    Begin
      Color := ColorOptionsSet.ColorOnFocus;
      Font.Color := ColorOptionsSet.ColorOnFocusFont;
    End
    Else
    Begin
      Color := ColorOptionsSet.ColorOnNotFocus;
      Font.Color := ColorOptionsSet.ColorOnNotFocusFont;
    End
  Else
  Begin
    Color := ColorOptionsSet.ColorOnDisabled;
    Font.Color := ColorOptionsSet.ColorOnDisabledFont;
  End
End;

{ lets see if there is something to do? }
procedure TPubComboBox.ListPick;
begin
  if Assigned(FOnListPick) then FOnListPick(Self);
end;

{ slightly modified CNCommand handler }
procedure TPubComboBox.CNCommand(var Message: TWMCommand);
begin
  case Message.NotifyCode of
    CBN_SELCHANGE: { in this case only, we will take over }
      begin
        Text := Items[ItemIndex];
        ListPick;
      end;
  else             { let mom handle the rest }
      inherited;
  end;
end;
{*****************}
{$IfDef useRXlibrary}
Constructor TPubDateEdit.Create(AOwner : TComponent);
Begin
  Inherited Create(AOwner);
  FColorOptionsSet := TColorOptionsSet.Create;
  Color           := ColorOptionsSet.ColorOnNotFocus;
  FRequired       := False;
End;

Destructor TPubDateEdit.Destroy;
Begin
  FColorOptionsSet.Free;
  Inherited Destroy;
End;

Procedure TPubDateEdit.SetRequired(Value:Boolean);
Begin
  If Value <> FRequired Then
    FRequired := Value;
End;

Procedure TPubDateEdit.DoEnter;
Begin
  {vybarvi pole pri zamereni}
  Color := ColorOptionsSet.ColorOnFocus;
  Font.Color := ColorOptionsSet.ColorOnFocusFont;

  if not AutoSelect then
    If Self.Date=0 Then SelStart := 0
    Else SelStart := GetTextLen;

  {vlastni funkce onenter}
  If Assigned(FOnEnter) Then
    FOnEnter(Self);
End;

Procedure TPubDateEdit.DoExit;
Begin
  {tady zmen barvu pole, kdyz ztracis zamereni}
  Color := ColorOptionsSet.ColorOnNotFocus;
  Font.Color := ColorOptionsSet.ColorOnNotFocusFont;

  {tohle je vlastni onexit}
  If Assigned(FOnExit) Then FOnExit(Self);

  {teprve po nem znovu overuji, zda je pole vyplneno dle pozadavku}
  If FRequired And (Text = '') Then Begin
    MessageBeep($ffff);
    SetFocus;
  End;

End;

Procedure TPubDateEdit.CMExit( Var Message : TCMExit );
Begin
  Inherited;
  {je-li pozadovano polozku vyplnit a ona je prazdna, pak znovu}
  {tady zadnou hlasku nezobrazuji}
  If FRequired And (Text='') Then Begin
    MessageBeep($ffff);
    Self.SetFocus;
    Exit;
  End;
End;

Procedure TPubDateEdit.CMEnter( Var Message : TCMEnter );
Begin
  Inherited;
End;

Procedure TPubDateEdit.CMEnabledChanged( Var Message : TMessage);
Begin
  Inherited;
  If Enabled Then
    If Focused Then
    Begin
      Color := ColorOptionsSet.ColorOnFocus;
      Font.Color := ColorOptionsSet.ColorOnFocusFont;
    End
    Else
    Begin
      Color := ColorOptionsSet.ColorOnNotFocus;
      Font.Color := ColorOptionsSet.ColorOnNotFocusFont;
    End
  Else
  Begin
    Color := ColorOptionsSet.ColorOnDisabled;
    Font.Color := ColorOptionsSet.ColorOnDisabledFont;
  End
End;

{*****************}

Constructor TPubFilenameEdit.Create(AOwner : TComponent);
Begin
  Inherited Create(AOwner);
  FColorOptionsSet := TColorOptionsSet.Create;
  Color           := ColorOptionsSet.ColorOnNotFocus;
  FRequired       := False;
End;

Destructor TPubFilenameEdit.Destroy;
Begin
  FColorOptionsSet.Free;
  Inherited Destroy;
End;

Procedure TPubFilenameEdit.SetRequired(Value:Boolean);
Begin
  If Value <> FRequired Then
    FRequired := Value;
End;

Procedure TPubFilenameEdit.DoEnter;
Begin
  {vybarvi pole pri zamereni}
  Color := ColorOptionsSet.ColorOnFocus;
  Font.Color := ColorOptionsSet.ColorOnFocusFont;

  {vlastni funkce onenter}
  If Assigned(FOnEnter) Then
    FOnEnter(Self);
End;

Procedure TPubFilenameEdit.DoExit;
Begin
  {tady zmen barvu pole, kdyz ztracis zamereni}
  Color := ColorOptionsSet.ColorOnNotFocus;
  Font.Color := ColorOptionsSet.ColorOnNotFocusFont;

  {tohle je vlastni onexit}
  If Assigned(FOnExit) Then FOnExit(Self);

  {teprve po nem znovu overuji, zda je pole vyplneno dle pozadavku}
  If FRequired And (Text = '') Then Begin
    MessageBeep($ffff);
    SetFocus;
  End;

End;

Procedure TPubFilenameEdit.CMExit( Var Message : TCMExit );
Begin
  Inherited;
  {je-li pozadovano polozku vyplnit a ona je prazdna, pak znovu}
  {tady zadnou hlasku nezobrazuji}
  If FRequired And (Text='') Then Begin
    MessageBeep($ffff);
    Self.SetFocus;
    Exit;
  End;
End;

Procedure TPubFilenameEdit.CMEnter( Var Message : TCMEnter );
Begin
  Inherited;
End;

Procedure TPubFilenameEdit.CMEnabledChanged( Var Message : TMessage);
Begin
  Inherited;
  If Enabled Then
    If Focused Then
    Begin
      Color := ColorOptionsSet.ColorOnFocus;
      Font.Color := ColorOptionsSet.ColorOnFocusFont;
    End
    Else
    Begin
      Color := ColorOptionsSet.ColorOnNotFocus;
      Font.Color := ColorOptionsSet.ColorOnNotFocusFont;
    End
  Else
  Begin
    Color := ColorOptionsSet.ColorOnDisabled;
    Font.Color := ColorOptionsSet.ColorOnDisabledFont;
  End
End;

{*****************}

Constructor TPubDirectoryEdit.Create(AOwner : TComponent);
Begin
  Inherited Create(AOwner);
  FColorOptionsSet := TColorOptionsSet.Create;
  Color           := ColorOptionsSet.ColorOnNotFocus;
  FRequired       := False;
End;

Destructor TPubDirectoryEdit.Destroy;
Begin
  FColorOptionsSet.Free;
  Inherited Destroy;
End;

Procedure TPubDirectoryEdit.SetRequired(Value:Boolean);
Begin
  If Value <> FRequired Then
    FRequired := Value;
End;

Procedure TPubDirectoryEdit.DoEnter;
Begin
  {vybarvi pole pri zamereni}
  Color := ColorOptionsSet.ColorOnFocus;
  Font.Color := ColorOptionsSet.ColorOnFocusFont;

  {vlastni funkce onenter}
  If Assigned(FOnEnter) Then
    FOnEnter(Self);
End;

Procedure TPubDirectoryEdit.DoExit;
Begin
  {tady zmen barvu pole, kdyz ztracis zamereni}
  Color := ColorOptionsSet.ColorOnNotFocus;
  Font.Color := ColorOptionsSet.ColorOnNotFocusFont;

  {tohle je vlastni onexit}
  If Assigned(FOnExit) Then FOnExit(Self);

  {teprve po nem znovu overuji, zda je pole vyplneno dle pozadavku}
  If FRequired And (Text = '') Then Begin
    MessageBeep($ffff);
    SetFocus;
  End;

End;

Procedure TPubDirectoryEdit.CMExit( Var Message : TCMExit );
Begin
  Inherited;
  {je-li pozadovano polozku vyplnit a ona je prazdna, pak znovu}
  {tady zadnou hlasku nezobrazuji}
  If FRequired And (Text='') Then Begin
    MessageBeep($ffff);
    Self.SetFocus;
    Exit;
  End;
End;

Procedure TPubDirectoryEdit.CMEnter( Var Message : TCMEnter );
Begin
  Inherited;
End;

Procedure TPubDirectoryEdit.CMEnabledChanged( Var Message : TMessage);
Begin
  Inherited;
  If Enabled Then
    If Focused Then
    Begin
      Color := ColorOptionsSet.ColorOnFocus;
      Font.Color := ColorOptionsSet.ColorOnFocusFont;
    End
    Else
    Begin
      Color := ColorOptionsSet.ColorOnNotFocus;
      Font.Color := ColorOptionsSet.ColorOnNotFocusFont;
    End
  Else
  Begin
    Color := ColorOptionsSet.ColorOnDisabled;
    Font.Color := ColorOptionsSet.ColorOnDisabledFont;
  End
End;

{*****************}

Constructor TPubRxCalcEdit.Create(AOwner : TComponent);
Begin
  Inherited Create(AOwner);
  FColorOptionsSet := TColorOptionsSet.Create;
  Color           := ColorOptionsSet.ColorOnNotFocus;
  FRequired       := False;
End;

Destructor TPubRxCalcEdit.Destroy;
Begin
  FColorOptionsSet.Free;
  Inherited Destroy;
End;

Procedure TPubRxCalcEdit.SetRequired(Value:Boolean);
Begin
  If Value <> FRequired Then
    FRequired := Value;
End;

Procedure TPubRxCalcEdit.DoEnter;
Begin
  {vybarvi pole pri zamereni}
  Color := ColorOptionsSet.ColorOnFocus;
  Font.Color := ColorOptionsSet.ColorOnFocusFont;

  {vlastni funkce onenter}
  If Assigned(FOnEnter) Then
    FOnEnter(Self);
End;

Procedure TPubRxCalcEdit.DoExit;
Begin
  {tady zmen barvu pole, kdyz ztracis zamereni}
  Color := ColorOptionsSet.ColorOnNotFocus;
  Font.Color := ColorOptionsSet.ColorOnNotFocusFont;

  {tohle je vlastni onexit}
  If Assigned(FOnExit) Then FOnExit(Self);

  {teprve po nem znovu overuji, zda je pole vyplneno dle pozadavku}
  If FRequired And (Text = '') Then Begin
    If BeepOnError Then MessageBeep($ffff);
    SetFocus;
  End;

End;

Procedure TPubRxCalcEdit.CMExit( Var Message : TCMExit );
Begin
  Inherited;
  {je-li pozadovano polozku vyplnit a ona je prazdna, pak znovu}
  {tady zadnou hlasku nezobrazuji}
  If FRequired And (Text='') Then Begin
    If BeepOnError Then MessageBeep($ffff);
    Self.SetFocus;
    Exit;
  End;
End;

Procedure TPubRxCalcEdit.CMEnter( Var Message : TCMEnter );
Begin
  Inherited;
End;

Procedure TPubRxCalcEdit.CMEnabledChanged( Var Message : TMessage);
Begin
  Inherited;
  If Enabled Then
    If Focused Then
    Begin
      Color := ColorOptionsSet.ColorOnFocus;
      Font.Color := ColorOptionsSet.ColorOnFocusFont;
    End
    Else
    Begin
      Color := ColorOptionsSet.ColorOnNotFocus;
      Font.Color := ColorOptionsSet.ColorOnNotFocusFont;
    End
  Else
  Begin
    Color := ColorOptionsSet.ColorOnDisabled;
    Font.Color := ColorOptionsSet.ColorOnDisabledFont;
  End
End;

{*****************}

Constructor TPubComboEdit.Create(AOwner : TComponent);
Begin
  Inherited Create(AOwner);
  FColorOptionsSet := TColorOptionsSet.Create;
  Color           := ColorOptionsSet.ColorOnNotFocus;
  FCapitalize     := False;
  FRequired       := False;
  FValids         := '';
  FMask           := '';
End;

Procedure TPubComboEdit.SetCapitalize(Value:Boolean);
Begin
  If Value <> FCapitalize Then
    FCapitalize := Value;
End;

Destructor TPubComboEdit.Destroy;
Begin
  FColorOptionsSet.Free;
  Inherited Destroy;
End;

Procedure TPubComboEdit.SetRequired(Value:Boolean);
Begin
  If Value <> FRequired Then
    FRequired := Value;
End;

Procedure TPubComboEdit.KeyPress(var Key: Char);
Var
 C: String;
 VCH: Set Of Char;
 I: Integer;
Begin
  {nejprve vyrob mnozinu znaku}
  VCH := [];
  If Length(FValids) > 0 Then
    For I := 1 To Length(FValids) Do
      Include(VCH,Chr(Ord(FValids[I])));
  {ohodnot}
  If (NOT (Key in ccControlKeys)) And (VCH <> []) Then
    If Not (Key In VCH) Then Key := #0; {Delej, jako by nebyla}

  {jsou-li pozadovana velka pismena na zacatku slov, udelej to tady}
  If FCapitalize Then
    If (SelStart = 0) Or (Text[SelStart] = ' ') Then
    Begin
      C := Key;
      C := AnsiUpperCase(C);
      Key := C[1];
    End;

  If Key <> #0 Then
    Inherited KeyPress(Key);
End;

Procedure TPubComboEdit.DoEnter;
Var S:String;
Begin
  {vybarvi pole pri zamereni}
  Color := ColorOptionsSet.ColorOnFocus;
  Font.Color := ColorOptionsSet.ColorOnFocusFont;
  If AsSigned(FConvert) Then
  Begin{je-li prislusna rutina}
    S:=Text;
    FConvert(Self,eValueToText,S); {preved text na jiny format}
    Text:=S;
  End;

  {je-li potreba zaformatovat podle masky, pak jenom pro string}
  If AsSigned(FMaskForm) Then
  Begin
    S := Text;
    FMaskForm(Self,eValueToText,FMask,S);
    Text := S;
  End;

  {vlastni funkce onenter}
  If Assigned(FOnEnter) Then
    FOnEnter(Self);
End;

Procedure TPubComboEdit.DoExit;
Var S:String;
Begin
  {tady zmen barvu pole, kdyz ztracis zamereni}
  Color := ColorOptionsSet.ColorOnNotFocus;
  Font.Color := ColorOptionsSet.ColorOnNotFocusFont;

  {je-li potreba zaformatovat podle masky, pak jenom pro string}
  If AsSigned(FMaskForm) Then Begin
    S := Text;
    FMaskForm(Self,eTextToValue,FMask,S);
    Text := S;
  End;

  If AsSigned(FConvert) Then Begin{je-li prislusna rutina}
    S:=Text;
    FConvert(Self,eTextToValue,S); {preved text na jiny format}
    Text:=S;
  End;

  {tohle je vlastni onexit}
  If Assigned(FOnExit) Then FOnExit(Self);

  {teprve po nem znovu overuji, zda je pole vyplneno dle pozadavku}
  If FRequired And (Text = '') Then Begin
    MessageBeep($ffff);
    SetFocus;
  End;
  {teprve po nem znovu overuji, zda je pole vyplneno dle pozadavku}
  If FRequired And (Text = '') Then Begin
    If AsSigned(FErrorOccur) Then
      {uzivatelska reakce na chybu}
      FErrorOccur(Self,msgFieldRequired)
    Else
      MessageDlg(msgFieldRequired,mtWarning, [mbOK],0);
    SetFocus;
  End;
End;

Procedure TPubComboEdit.CMExit( Var Message : TCMExit );
Var
  S:String;
  CanExit:Boolean;
Begin
  Inherited;
  {je-li pozadovano polozku vyplnit a ona je prazdna, pak znovu}
  {tady zadnou hlasku nezobrazuji}
  If FRequired And (Text='') Then Begin
    MessageBeep($ffff);
    Self.SetFocus;
    Exit;
  End;
  If Assigned(FValidate) Then Begin
    S:=Text;
    FValidate(Self, S, CanExit);
    If S<>Text Then {in validate can be changed, update it !}
      Text:=S;
    If Not CanExit Then Begin  {fatal error in validate}
      MessageBeep($ffff);
      Self.SetFocus;
      Exit;
    End;
  End;
End;

Procedure TPubComboEdit.CMEnter( Var Message : TCMEnter );
Begin
  Inherited;
End;

Procedure TPubComboEdit.CMEnabledChanged( Var Message : TMessage);
Begin
  Inherited;
  If Enabled Then
    If Focused Then
    Begin
      Color := ColorOptionsSet.ColorOnFocus;
      Font.Color := ColorOptionsSet.ColorOnFocusFont;
    End
    Else
    Begin
      Color := ColorOptionsSet.ColorOnNotFocus;
      Font.Color := ColorOptionsSet.ColorOnNotFocusFont;
    End
  Else
  Begin
    Color := ColorOptionsSet.ColorOnDisabled;
    Font.Color := ColorOptionsSet.ColorOnDisabledFont;
  End
End;
{$EndIf useRXlibrary}
Procedure Register;
Begin
  RegisterComponents('Library',[TPubEdit,
                                TPubMaskEdit,
                                {$IfDef useRXlibrary}
                                TPubCurrencyEdit,
                                {$EndIf useRXlibrary}
                                TPubComboBox,
                                {$IfDef useRXlibrary}
                                TPubDateEdit,
                                TPubFilenameEdit,
                                TPubDirectoryEdit,
                                TPubComboEdit,
                                TPubRxCalcEdit
                                {$EndIf useRXlibrary}
                               ]);
End;

End.


